require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_CHAFSR_H)) {
    eval 'sub _SPARC64_CHAFSR_H () {1;}' unless defined(&_SPARC64_CHAFSR_H);
    eval 'sub CHAFSR_ME () {9.00719925474099e+15;}' unless defined(&CHAFSR_ME);
    eval 'sub CHAFSR_PRIV () {4.5035996273705e+15;}' unless defined(&CHAFSR_PRIV);
    eval 'sub CHAFSR_PERR () {2.25179981368525e+15;}' unless defined(&CHAFSR_PERR);
    eval 'sub CHAFSR_IERR () {1.12589990684262e+15;}' unless defined(&CHAFSR_IERR);
    eval 'sub CHAFSR_ISAP () {562949953421312;}' unless defined(&CHAFSR_ISAP);
    eval 'sub CHAFSR_EMC () {281474976710656;}' unless defined(&CHAFSR_EMC);
    eval 'sub CHAFSR_EMU () {140737488355328;}' unless defined(&CHAFSR_EMU);
    eval 'sub CHAFSR_IVC () {70368744177664;}' unless defined(&CHAFSR_IVC);
    eval 'sub CHAFSR_IVU () {35184372088832;}' unless defined(&CHAFSR_IVU);
    eval 'sub CHAFSR_TO () {17592186044416;}' unless defined(&CHAFSR_TO);
    eval 'sub CHAFSR_BERR () {8796093022208;}' unless defined(&CHAFSR_BERR);
    eval 'sub CHAFSR_UCC () {4398046511104;}' unless defined(&CHAFSR_UCC);
    eval 'sub CHAFSR_UCU () {2199023255552;}' unless defined(&CHAFSR_UCU);
    eval 'sub CHAFSR_CPC () {1099511627776;}' unless defined(&CHAFSR_CPC);
    eval 'sub CHAFSR_CPU () {549755813888;}' unless defined(&CHAFSR_CPU);
    eval 'sub CHAFSR_WDC () {274877906944;}' unless defined(&CHAFSR_WDC);
    eval 'sub CHAFSR_WDU () {137438953472;}' unless defined(&CHAFSR_WDU);
    eval 'sub CHAFSR_EDC () {68719476736;}' unless defined(&CHAFSR_EDC);
    eval 'sub CHAFSR_EDU () {34359738368;}' unless defined(&CHAFSR_EDU);
    eval 'sub CHAFSR_UE () {17179869184;}' unless defined(&CHAFSR_UE);
    eval 'sub CHAFSR_CE () {8589934592;}' unless defined(&CHAFSR_CE);
    eval 'sub CHAFSR_ERRORS () {( &CHAFSR_PERR |  &CHAFSR_IERR |  &CHAFSR_ISAP |  &CHAFSR_EMC |  &CHAFSR_EMU |  &CHAFSR_IVC |  &CHAFSR_IVU |  &CHAFSR_TO |  &CHAFSR_BERR |  &CHAFSR_UCC |  &CHAFSR_UCU |  &CHAFSR_CPC |  &CHAFSR_CPU |  &CHAFSR_WDC |  &CHAFSR_WDU |  &CHAFSR_EDC |  &CHAFSR_EDU |  &CHAFSR_UE |  &CHAFSR_CE);}' unless defined(&CHAFSR_ERRORS);
    eval 'sub CHAFSR_M_SYNDROME () {0xf0000;}' unless defined(&CHAFSR_M_SYNDROME);
    eval 'sub CHAFSR_M_SYNDROME_SHIFT () {16;}' unless defined(&CHAFSR_M_SYNDROME_SHIFT);
    eval 'sub CHAFSR_E_SYNDROME () {0x1ff;}' unless defined(&CHAFSR_E_SYNDROME);
    eval 'sub CHAFSR_E_SYNDROME_SHIFT () {0;}' unless defined(&CHAFSR_E_SYNDROME_SHIFT);
    eval 'sub CHAFSR_TL1 () {9.22337203685478e+18;}' unless defined(&CHAFSR_TL1);
}
1;
