require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_DELAY_H)) {
    eval 'sub __SPARC64_DELAY_H () {1;}' unless defined(&__SPARC64_DELAY_H);
    require 'linux/config.ph';
    require 'linux/param.ph';
    unless(defined(&__ASSEMBLY__)) {
	if(defined(&CONFIG_SMP)) {
	    require 'asm/smp.ph';
	} else {
	}
	if(defined(&CONFIG_SMP)) {
	    eval 'sub __udelay_val () { ($cpu_data[&smp_processor_id()]->{udelay_val});}' unless defined(&__udelay_val);
	} else {
	    eval 'sub __udelay_val () { &loops_per_jiffy;}' unless defined(&__udelay_val);
	}
	eval 'sub udelay {
	    local($usecs) = @_;
    	    eval q( &__udelay(($usecs), &__udelay_val));
	}' unless defined(&udelay);
	eval 'sub ndelay {
	    local($usecs) = @_;
    	    eval q( &__ndelay(($usecs), &__udelay_val));
	}' unless defined(&ndelay);
    }
}
1;
