require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPARC64_PROCESSOR_H)) {
    eval 'sub __ASM_SPARC64_PROCESSOR_H () {1;}' unless defined(&__ASM_SPARC64_PROCESSOR_H);
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &__asm__(\\"rd %%pc, %0\\" : \\"=r\\" ( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    require 'linux/config.ph';
    require 'asm/asi.ph';
    require 'asm/a.out.ph';
    require 'asm/pstate.ph';
    require 'asm/ptrace.ph';
    require 'asm/signal.ph';
    require 'asm/segment.ph';
    require 'asm/page.ph';
    require 'asm/delay.ph';
    eval 'sub EISA_bus () {0;}' unless defined(&EISA_bus);
    eval 'sub EISA_bus__is_a_macro () {1;}' unless defined(&EISA_bus__is_a_macro);
    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
    eval 'sub wp_works_ok () {1;}' unless defined(&wp_works_ok);
    eval 'sub wp_works_ok__is_a_macro () {1;}' unless defined(&wp_works_ok__is_a_macro);
    eval 'sub VA_BITS () {44;}' unless defined(&VA_BITS);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub VPTE_SIZE () {(1 << ( &VA_BITS -  &PAGE_SHIFT + 3));}' unless defined(&VPTE_SIZE);
    } else {
	eval 'sub VPTE_SIZE () {(1<< ( &VA_BITS -  &PAGE_SHIFT + 3));}' unless defined(&VPTE_SIZE);
    }
    eval 'sub TASK_SIZE () {(- &VPTE_SIZE);}' unless defined(&TASK_SIZE);
    eval 'sub VPTE_BASE_SPITFIRE () {(-( &VPTE_SIZE/2));}' unless defined(&VPTE_BASE_SPITFIRE);
    if(1) {
	eval 'sub VPTE_BASE_CHEETAH () { &VPTE_BASE_SPITFIRE;}' unless defined(&VPTE_BASE_CHEETAH);
    } else {
	eval 'sub VPTE_BASE_CHEETAH () {1.84377368744548e+19;}' unless defined(&VPTE_BASE_CHEETAH);
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub NSWINS () {7;}' unless defined(&NSWINS);
	if(defined(&CONFIG_DEBUG_SPINLOCK)) {
	}
    }
    eval 'sub SPARC_FLAG_UNALIGNED () {0x1;}' unless defined(&SPARC_FLAG_UNALIGNED);
    eval 'sub SPARC_FLAG_NEWSIGNALS () {0x2;}' unless defined(&SPARC_FLAG_NEWSIGNALS);
    eval 'sub SPARC_FLAG_32BIT () {0x4;}' unless defined(&SPARC_FLAG_32BIT);
    eval 'sub SPARC_FLAG_NEWCHILD () {0x8;}' unless defined(&SPARC_FLAG_NEWCHILD);
    eval 'sub SPARC_FLAG_PERFCTR () {0x10;}' unless defined(&SPARC_FLAG_PERFCTR);
    eval 'sub SPARC_FLAG_ABI_PENDING () {0x20;}' unless defined(&SPARC_FLAG_ABI_PENDING);
    eval 'sub FAULT_CODE_WRITE () {0x1;}' unless defined(&FAULT_CODE_WRITE);
    eval 'sub FAULT_CODE_DTLB () {0x2;}' unless defined(&FAULT_CODE_DTLB);
    eval 'sub FAULT_CODE_ITLB () {0x4;}' unless defined(&FAULT_CODE_ITLB);
    eval 'sub FAULT_CODE_WINFIXUP () {0x8;}' unless defined(&FAULT_CODE_WINFIXUP);
    unless(defined(&CONFIG_DEBUG_SPINLOCK)) {
	eval 'sub INIT_THREAD () {{ 0, 0, 0, 0,  &KERNEL_DS, 0, 0, 0, 0, 0, { 0}, 0, 0, 0, { 0}, { 0}, { { { 0, }, { 0, } }, }, { 0, 0, 0, 0, 0, 0, 0, }, 0, 0, 0, 0, 0, };}' unless defined(&INIT_THREAD);
    } else {
	eval 'sub INIT_THREAD () {{ 0, 0, 0, 0,  &KERNEL_DS, 0, 0, 0, 0, 0, { 0}, 0, 0, 0, { 0}, { 0}, 0, 0, { { { 0, }, { 0, } }, }, { 0, 0, 0, 0, 0, 0, 0, }, 0, 0, 0, 0, 0, };}' unless defined(&INIT_THREAD);
    }
    if(defined(&__KERNEL__)) {
	if((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 13) {
	    eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
	    eval 'sub THREAD_SHIFT () {( &PAGE_SHIFT + 1);}' unless defined(&THREAD_SHIFT);
	} else {
	    eval 'sub THREAD_SIZE () { &PAGE_SIZE;}' unless defined(&THREAD_SIZE);
	    eval 'sub THREAD_SHIFT () { &PAGE_SHIFT;}' unless defined(&THREAD_SHIFT);
	}
    }
    unless(defined(&__ASSEMBLY__)) {
	if(defined(&CONFIG_SMP)) {
	    eval 'sub TSTATE_INITIAL_MM () { &TSTATE_TSO;}' unless defined(&TSTATE_INITIAL_MM);
	} else {
	    eval 'sub TSTATE_INITIAL_MM () { &TSTATE_RMO;}' unless defined(&TSTATE_INITIAL_MM);
	}
	eval 'sub start_thread {
	    local($regs, $pc, $sp) = @_;
    	    eval q( &do {  ($regs->{tstate}) = ( ($regs->{tstate}) & ) | ( &TSTATE_INITIAL_MM| &TSTATE_IE) | ( &ASI_PNF << 24);  ($regs->{t$pc}) = (($pc & (~3)) - 4);  ($regs->{tnpc}) =  ($regs->{t$pc}) + 4;  ($regs->{y}) = 0;  ($current->{thread}->{wstate}) = (1<< 3);  &if ( ($current->{thread}->{utraps})) {  &if (*( ($current->{thread}->{utraps})) < 2)  &kfree ( ($current->{thread}->{utraps}));  &else (*( ($current->{thread}->{utraps})))--;  ($current->{thread}->{utraps}) =  &NULL; }  &__asm__  &__volatile__( \\"stx		%%g0, [%0 + %2 + 0x00]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x08]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x10]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x18]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x20]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x28]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x30]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x38]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x40]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x48]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x50]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x58]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x60]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x68]\\\\n\\\\t\\" \\"stx		%1,   [%0 + %2 + 0x70]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x78]\\\\n\\\\t\\" \\"wrpr		%%g0, (1 << 3), %%wstate\\\\n\\\\t\\" : : \\"r\\" , \\"r\\" ($sp -  &sizeof -  &STACK_BIAS), \\"i\\" (((0)-> $u_regs[0]))); }  &while(0));
	}' unless defined(&start_thread);
	eval 'sub start_thread32 {
	    local($regs, $pc, $sp) = @_;
    	    eval q( &do { $pc &= 0xffffffff; $sp &= 0xffffffff;  ($regs->{tstate}) = ( ($regs->{tstate}) & )|( &TSTATE_INITIAL_MM| &TSTATE_IE| &TSTATE_AM);  ($regs->{t$pc}) = (($pc & (~3)) - 4);  ($regs->{tnpc}) =  ($regs->{t$pc}) + 4;  ($regs->{y}) = 0;  ($current->{thread}->{wstate}) = (2<< 3);  &if ( ($current->{thread}->{utraps})) {  &if (*( ($current->{thread}->{utraps})) < 2)  &kfree ( ($current->{thread}->{utraps}));  &else (*( ($current->{thread}->{utraps})))--;  ($current->{thread}->{utraps}) =  &NULL; }  &__asm__  &__volatile__( \\"stx		%%g0, [%0 + %2 + 0x00]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x08]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x10]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x18]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x20]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x28]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x30]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x38]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x40]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x48]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x50]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x58]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x60]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x68]\\\\n\\\\t\\" \\"stx		%1,   [%0 + %2 + 0x70]\\\\n\\\\t\\" \\"stx		%%g0, [%0 + %2 + 0x78]\\\\n\\\\t\\" \\"wrpr		%%g0, (2 << 3), %%wstate\\\\n\\\\t\\" : : \\"r\\" , \\"r\\" ($sp -  &sizeof), \\"i\\" (((0)-> $u_regs[0]))); }  &while(0));
	}' unless defined(&start_thread32);
	eval 'sub release_thread {
	    local($tsk) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&release_thread);
	eval 'sub copy_segments {
	    local($tsk, $mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&copy_segments);
	eval 'sub release_segments {
	    local($mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&release_segments);
	eval 'sub get_wchan {
	    local($__TSK) = @_;
    	    eval q(({  &extern  &void  &scheduling_functions_start_here;  &extern  &void  &scheduling_functions_end_here; \'unsigned long pc\',  &fp,  &bias = 0; \'unsigned long task_base\' = ; \'struct reg_window\' * &rw; \'unsigned long __ret\' = 0; \'int\'  &count = 0;  &if (! || ==  &current || -> &state ==  &TASK_RUNNING)  &goto  &__out;  &bias =  &STACK_BIAS;  &fp = -> ($thread->{ksp}) +  &bias;  &do {  &if ( &fp < ( &task_base +  &sizeof) ||  &fp >= ( &task_base +  &THREAD_SIZE))  &break;  &rw =  &fp;  &pc =  ($rw->{ins[7]});  &if ( &pc < ||  &pc >= (  &scheduling_functions_end_here)) {  &__ret =  &pc;  &goto  &__out; }  &fp =  ($rw->{ins[6]}) +  &bias; }  &while (++ &count < 16);  &__out:  &__ret; }));
	}' unless defined(&get_wchan);
	eval 'sub KSTK_EIP {
	    local($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{kregs}->{tpc})));
	}' unless defined(&KSTK_EIP);
	eval 'sub KSTK_ESP {
	    local($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{kregs}->{u_regs[&UREG_FP]})));
	}' unless defined(&KSTK_ESP);
	if(defined(&__KERNEL__)) {
	    if((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 13) {
		eval 'sub alloc_task_struct () {
		    eval q(( &__get_free_pages( &GFP_KERNEL, 1)));
		}' unless defined(&alloc_task_struct);
		eval 'sub free_task_struct {
		    local($tsk) = @_;
    		    eval q( &free_pages(($tsk),1));
		}' unless defined(&free_task_struct);
	    } else {
		eval 'sub alloc_task_struct () {
		    eval q(( &__get_free_pages( &GFP_KERNEL, 0)));
		}' unless defined(&alloc_task_struct);
		eval 'sub free_task_struct {
		    local($tsk) = @_;
    		    eval q( &free_pages(($tsk),0));
		}' unless defined(&free_task_struct);
	    }
	    eval 'sub get_task_struct {
	        local($tsk) = @_;
    		eval q( &atomic_inc( &virt_to_page($tsk)-> &count));
	    }' unless defined(&get_task_struct);
	    eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	    eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
	    eval 'sub cpu_relax () {
	        eval q( &udelay(1+  &smp_processor_id()));
	    }' unless defined(&cpu_relax);
	}
    }
}
1;
