require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASMSPARC_ELF_H)) {
    eval 'sub __ASMSPARC_ELF_H () {1;}' unless defined(&__ASMSPARC_ELF_H);
    require 'linux/config.ph';
    require 'asm/ptrace.ph';
    require 'asm/mbus.ph';
    eval 'sub ELF_NGREG () {38;}' unless defined(&ELF_NGREG);
    eval 'sub ELF_CORE_COPY_REGS {
        local($__elf_regs, $__pt_regs) = @_;
	    eval q( &do { \'unsigned long\' * &dest = ($__elf_regs->[0]); \'struct pt_regs\' * &src = ; \'unsigned long\' * &sp;  &memcpy( $dest[0],  ($src->{u_regs[0]}),  &sizeof * 16);  &set_fs;  &sp =  ($src->{u_regs[14]});  &copy_from_user( $dest[16],  &sp, $sizeof{\'unsigned long\'} * 16);  &set_fs( &KERNEL_DS);  $dest[32] =  ($src->{psr});  $dest[33] =  ($src->{pc});  $dest[34] =  ($src->{npc});  $dest[35] =  ($src->{y});  $dest[36] =  $dest[37] = 0; }  &while(0););
    }' unless defined(&ELF_CORE_COPY_REGS);
    eval 'sub elf_check_arch {
        local($x) = @_;
	    eval q((($x)-> &e_machine ==  &EM_SPARC));
    }' unless defined(&elf_check_arch);
    eval 'sub ELF_ARCH () { &EM_SPARC;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
    eval 'sub ELF_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_DATA);
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    unless(defined(&CONFIG_SUN4)) {
	eval 'sub ELF_EXEC_PAGESIZE () {4096;}' unless defined(&ELF_EXEC_PAGESIZE);
    } else {
	eval 'sub ELF_EXEC_PAGESIZE () {8192;}' unless defined(&ELF_EXEC_PAGESIZE);
    }
    eval 'sub ELF_ET_DYN_BASE () {(0x8000000);}' unless defined(&ELF_ET_DYN_BASE);
    eval 'sub ELF_HWCAP () {(( &ARCH_SUN4C_SUN4) ? 0: ( &HWCAP_SPARC_FLUSH |  &HWCAP_SPARC_STBAR |  &HWCAP_SPARC_SWAP | (( &srmmu_modtype !=  &Cypress  &&  &srmmu_modtype !=  &Cypress_vE  &&  &srmmu_modtype !=  &Cypress_vD) ?  &HWCAP_SPARC_MULDIV : 0)));}' unless defined(&ELF_HWCAP);
    eval 'sub ELF_PLATFORM () {( &NULL);}' unless defined(&ELF_PLATFORM);
    if(defined(&__KERNEL__)) {
	eval 'sub SET_PERSONALITY {
	    local($ex, $ibcs2) = @_;
    	    eval q( &set_personality(($ibcs2)? &PER_SVR4: &PER_LINUX));
	}' unless defined(&SET_PERSONALITY);
    }
}
1;
