require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_OFFSETS_H__)) {
    eval 'sub __ASM_OFFSETS_H__ () {1;}' unless defined(&__ASM_OFFSETS_H__);
    require 'linux/config.ph';
    unless(defined(&CONFIG_SMP)) {
	eval 'sub AOFF_task_state () {0x;}' unless defined(&AOFF_task_state);
	eval 'sub ASIZ_task_state () {0x8;}' unless defined(&ASIZ_task_state);
	eval 'sub AOFF_task_flags () {0x8;}' unless defined(&AOFF_task_flags);
	eval 'sub ASIZ_task_flags () {0x8;}' unless defined(&ASIZ_task_flags);
	eval 'sub AOFF_task_sigpending () {0x10;}' unless defined(&AOFF_task_sigpending);
	eval 'sub ASIZ_task_sigpending () {0x4;}' unless defined(&ASIZ_task_sigpending);
	eval 'sub AOFF_task_addr_limit () {0x14;}' unless defined(&AOFF_task_addr_limit);
	eval 'sub ASIZ_task_addr_limit () {0x1;}' unless defined(&ASIZ_task_addr_limit);
	eval 'sub AOFF_task_exec_domain () {0x18;}' unless defined(&AOFF_task_exec_domain);
	eval 'sub ASIZ_task_exec_domain () {0x8;}' unless defined(&ASIZ_task_exec_domain);
	eval 'sub AOFF_task_need_resched () {0x20;}' unless defined(&AOFF_task_need_resched);
	eval 'sub ASIZ_task_need_resched () {0x8;}' unless defined(&ASIZ_task_need_resched);
	eval 'sub AOFF_task_ptrace () {0x28;}' unless defined(&AOFF_task_ptrace);
	eval 'sub ASIZ_task_ptrace () {0x8;}' unless defined(&ASIZ_task_ptrace);
	eval 'sub AOFF_task_lock_depth () {0x30;}' unless defined(&AOFF_task_lock_depth);
	eval 'sub ASIZ_task_lock_depth () {0x4;}' unless defined(&ASIZ_task_lock_depth);
	eval 'sub AOFF_task_counter () {0x38;}' unless defined(&AOFF_task_counter);
	eval 'sub ASIZ_task_counter () {0x8;}' unless defined(&ASIZ_task_counter);
	eval 'sub AOFF_task_nice () {0x40;}' unless defined(&AOFF_task_nice);
	eval 'sub ASIZ_task_nice () {0x8;}' unless defined(&ASIZ_task_nice);
	eval 'sub AOFF_task_policy () {0x48;}' unless defined(&AOFF_task_policy);
	eval 'sub ASIZ_task_policy () {0x8;}' unless defined(&ASIZ_task_policy);
	eval 'sub AOFF_task_mm () {0x50;}' unless defined(&AOFF_task_mm);
	eval 'sub ASIZ_task_mm () {0x8;}' unless defined(&ASIZ_task_mm);
	eval 'sub AOFF_task_processor () {0x58;}' unless defined(&AOFF_task_processor);
	eval 'sub ASIZ_task_processor () {0x4;}' unless defined(&ASIZ_task_processor);
	eval 'sub AOFF_task_cpus_runnable () {0x60;}' unless defined(&AOFF_task_cpus_runnable);
	eval 'sub ASIZ_task_cpus_runnable () {0x8;}' unless defined(&ASIZ_task_cpus_runnable);
	eval 'sub AOFF_task_cpus_allowed () {0x68;}' unless defined(&AOFF_task_cpus_allowed);
	eval 'sub ASIZ_task_cpus_allowed () {0x8;}' unless defined(&ASIZ_task_cpus_allowed);
	eval 'sub AOFF_task_run_list () {0x70;}' unless defined(&AOFF_task_run_list);
	eval 'sub ASIZ_task_run_list () {0x10;}' unless defined(&ASIZ_task_run_list);
	eval 'sub AOFF_task_sleep_time () {0x80;}' unless defined(&AOFF_task_sleep_time);
	eval 'sub ASIZ_task_sleep_time () {0x8;}' unless defined(&ASIZ_task_sleep_time);
	eval 'sub AOFF_task_next_task () {0x88;}' unless defined(&AOFF_task_next_task);
	eval 'sub ASIZ_task_next_task () {0x8;}' unless defined(&ASIZ_task_next_task);
	eval 'sub AOFF_task_prev_task () {0x90;}' unless defined(&AOFF_task_prev_task);
	eval 'sub ASIZ_task_prev_task () {0x8;}' unless defined(&ASIZ_task_prev_task);
	eval 'sub AOFF_task_active_mm () {0x98;}' unless defined(&AOFF_task_active_mm);
	eval 'sub ASIZ_task_active_mm () {0x8;}' unless defined(&ASIZ_task_active_mm);
	eval 'sub AOFF_task_local_pages () {0xa0;}' unless defined(&AOFF_task_local_pages);
	eval 'sub ASIZ_task_local_pages () {0x10;}' unless defined(&ASIZ_task_local_pages);
	eval 'sub AOFF_task_allocation_order () {0xb0;}' unless defined(&AOFF_task_allocation_order);
	eval 'sub ASIZ_task_allocation_order () {0x4;}' unless defined(&ASIZ_task_allocation_order);
	eval 'sub AOFF_task_nr_local_pages () {0xb4;}' unless defined(&AOFF_task_nr_local_pages);
	eval 'sub ASIZ_task_nr_local_pages () {0x4;}' unless defined(&ASIZ_task_nr_local_pages);
	eval 'sub AOFF_task_binfmt () {0xb8;}' unless defined(&AOFF_task_binfmt);
	eval 'sub ASIZ_task_binfmt () {0x8;}' unless defined(&ASIZ_task_binfmt);
	eval 'sub AOFF_task_exit_code () {0xc0;}' unless defined(&AOFF_task_exit_code);
	eval 'sub ASIZ_task_exit_code () {0x4;}' unless defined(&ASIZ_task_exit_code);
	eval 'sub AOFF_task_exit_signal () {0xc4;}' unless defined(&AOFF_task_exit_signal);
	eval 'sub ASIZ_task_exit_signal () {0x4;}' unless defined(&ASIZ_task_exit_signal);
	eval 'sub AOFF_task_pdeath_signal () {0xc8;}' unless defined(&AOFF_task_pdeath_signal);
	eval 'sub ASIZ_task_pdeath_signal () {0x4;}' unless defined(&ASIZ_task_pdeath_signal);
	eval 'sub AOFF_task_personality () {0xd0;}' unless defined(&AOFF_task_personality);
	eval 'sub ASIZ_task_personality () {0x8;}' unless defined(&ASIZ_task_personality);
	eval 'sub AOFF_task_pid () {0xdc;}' unless defined(&AOFF_task_pid);
	eval 'sub ASIZ_task_pid () {0x4;}' unless defined(&ASIZ_task_pid);
	eval 'sub AOFF_task_pgrp () {0xe0;}' unless defined(&AOFF_task_pgrp);
	eval 'sub ASIZ_task_pgrp () {0x4;}' unless defined(&ASIZ_task_pgrp);
	eval 'sub AOFF_task_tty_old_pgrp () {0xe4;}' unless defined(&AOFF_task_tty_old_pgrp);
	eval 'sub ASIZ_task_tty_old_pgrp () {0x4;}' unless defined(&ASIZ_task_tty_old_pgrp);
	eval 'sub AOFF_task_session () {0xe8;}' unless defined(&AOFF_task_session);
	eval 'sub ASIZ_task_session () {0x4;}' unless defined(&ASIZ_task_session);
	eval 'sub AOFF_task_tgid () {0xec;}' unless defined(&AOFF_task_tgid);
	eval 'sub ASIZ_task_tgid () {0x4;}' unless defined(&ASIZ_task_tgid);
	eval 'sub AOFF_task_leader () {0xf0;}' unless defined(&AOFF_task_leader);
	eval 'sub ASIZ_task_leader () {0x4;}' unless defined(&ASIZ_task_leader);
	eval 'sub AOFF_task_p_opptr () {0xf8;}' unless defined(&AOFF_task_p_opptr);
	eval 'sub ASIZ_task_p_opptr () {0x8;}' unless defined(&ASIZ_task_p_opptr);
	eval 'sub AOFF_task_p_pptr () {0x100;}' unless defined(&AOFF_task_p_pptr);
	eval 'sub ASIZ_task_p_pptr () {0x8;}' unless defined(&ASIZ_task_p_pptr);
	eval 'sub AOFF_task_p_cptr () {0x108;}' unless defined(&AOFF_task_p_cptr);
	eval 'sub ASIZ_task_p_cptr () {0x8;}' unless defined(&ASIZ_task_p_cptr);
	eval 'sub AOFF_task_p_ysptr () {0x110;}' unless defined(&AOFF_task_p_ysptr);
	eval 'sub ASIZ_task_p_ysptr () {0x8;}' unless defined(&ASIZ_task_p_ysptr);
	eval 'sub AOFF_task_p_osptr () {0x118;}' unless defined(&AOFF_task_p_osptr);
	eval 'sub ASIZ_task_p_osptr () {0x8;}' unless defined(&ASIZ_task_p_osptr);
	eval 'sub AOFF_task_thread_group () {0x120;}' unless defined(&AOFF_task_thread_group);
	eval 'sub ASIZ_task_thread_group () {0x10;}' unless defined(&ASIZ_task_thread_group);
	eval 'sub AOFF_task_pidhash_next () {0x130;}' unless defined(&AOFF_task_pidhash_next);
	eval 'sub ASIZ_task_pidhash_next () {0x8;}' unless defined(&ASIZ_task_pidhash_next);
	eval 'sub AOFF_task_pidhash_pprev () {0x138;}' unless defined(&AOFF_task_pidhash_pprev);
	eval 'sub ASIZ_task_pidhash_pprev () {0x8;}' unless defined(&ASIZ_task_pidhash_pprev);
	eval 'sub AOFF_task_wait_chldexit () {0x140;}' unless defined(&AOFF_task_wait_chldexit);
	eval 'sub ASIZ_task_wait_chldexit () {0x10;}' unless defined(&ASIZ_task_wait_chldexit);
	eval 'sub AOFF_task_vfork_done () {0x150;}' unless defined(&AOFF_task_vfork_done);
	eval 'sub ASIZ_task_vfork_done () {0x8;}' unless defined(&ASIZ_task_vfork_done);
	eval 'sub AOFF_task_rt_priority () {0x158;}' unless defined(&AOFF_task_rt_priority);
	eval 'sub ASIZ_task_rt_priority () {0x8;}' unless defined(&ASIZ_task_rt_priority);
	eval 'sub AOFF_task_it_real_value () {0x160;}' unless defined(&AOFF_task_it_real_value);
	eval 'sub ASIZ_task_it_real_value () {0x8;}' unless defined(&ASIZ_task_it_real_value);
	eval 'sub AOFF_task_it_prof_value () {0x168;}' unless defined(&AOFF_task_it_prof_value);
	eval 'sub ASIZ_task_it_prof_value () {0x8;}' unless defined(&ASIZ_task_it_prof_value);
	eval 'sub AOFF_task_it_virt_value () {0x170;}' unless defined(&AOFF_task_it_virt_value);
	eval 'sub ASIZ_task_it_virt_value () {0x8;}' unless defined(&ASIZ_task_it_virt_value);
	eval 'sub AOFF_task_it_real_incr () {0x178;}' unless defined(&AOFF_task_it_real_incr);
	eval 'sub ASIZ_task_it_real_incr () {0x8;}' unless defined(&ASIZ_task_it_real_incr);
	eval 'sub AOFF_task_it_prof_incr () {0x180;}' unless defined(&AOFF_task_it_prof_incr);
	eval 'sub ASIZ_task_it_prof_incr () {0x8;}' unless defined(&ASIZ_task_it_prof_incr);
	eval 'sub AOFF_task_it_virt_incr () {0x188;}' unless defined(&AOFF_task_it_virt_incr);
	eval 'sub ASIZ_task_it_virt_incr () {0x8;}' unless defined(&ASIZ_task_it_virt_incr);
	eval 'sub AOFF_task_real_timer () {0x190;}' unless defined(&AOFF_task_real_timer);
	eval 'sub ASIZ_task_real_timer () {0x28;}' unless defined(&ASIZ_task_real_timer);
	eval 'sub AOFF_task_times () {0x1b8;}' unless defined(&AOFF_task_times);
	eval 'sub ASIZ_task_times () {0x20;}' unless defined(&ASIZ_task_times);
	eval 'sub AOFF_task_start_time () {0x1d8;}' unless defined(&AOFF_task_start_time);
	eval 'sub ASIZ_task_start_time () {0x8;}' unless defined(&ASIZ_task_start_time);
	eval 'sub AOFF_task_per_cpu_utime () {0x1e0;}' unless defined(&AOFF_task_per_cpu_utime);
	eval 'sub ASIZ_task_per_cpu_utime () {0x8;}' unless defined(&ASIZ_task_per_cpu_utime);
	eval 'sub AOFF_task_min_flt () {0x1f0;}' unless defined(&AOFF_task_min_flt);
	eval 'sub ASIZ_task_min_flt () {0x8;}' unless defined(&ASIZ_task_min_flt);
	eval 'sub AOFF_task_maj_flt () {0x1f8;}' unless defined(&AOFF_task_maj_flt);
	eval 'sub ASIZ_task_maj_flt () {0x8;}' unless defined(&ASIZ_task_maj_flt);
	eval 'sub AOFF_task_nswap () {0x200;}' unless defined(&AOFF_task_nswap);
	eval 'sub ASIZ_task_nswap () {0x8;}' unless defined(&ASIZ_task_nswap);
	eval 'sub AOFF_task_cmin_flt () {0x208;}' unless defined(&AOFF_task_cmin_flt);
	eval 'sub ASIZ_task_cmin_flt () {0x8;}' unless defined(&ASIZ_task_cmin_flt);
	eval 'sub AOFF_task_cmaj_flt () {0x210;}' unless defined(&AOFF_task_cmaj_flt);
	eval 'sub ASIZ_task_cmaj_flt () {0x8;}' unless defined(&ASIZ_task_cmaj_flt);
	eval 'sub AOFF_task_cnswap () {0x218;}' unless defined(&AOFF_task_cnswap);
	eval 'sub ASIZ_task_cnswap () {0x8;}' unless defined(&ASIZ_task_cnswap);
	eval 'sub AOFF_task_uid () {0x224;}' unless defined(&AOFF_task_uid);
	eval 'sub ASIZ_task_uid () {0x4;}' unless defined(&ASIZ_task_uid);
	eval 'sub AOFF_task_euid () {0x228;}' unless defined(&AOFF_task_euid);
	eval 'sub ASIZ_task_euid () {0x4;}' unless defined(&ASIZ_task_euid);
	eval 'sub AOFF_task_suid () {0x22c;}' unless defined(&AOFF_task_suid);
	eval 'sub ASIZ_task_suid () {0x4;}' unless defined(&ASIZ_task_suid);
	eval 'sub AOFF_task_fsuid () {0x230;}' unless defined(&AOFF_task_fsuid);
	eval 'sub ASIZ_task_fsuid () {0x4;}' unless defined(&ASIZ_task_fsuid);
	eval 'sub AOFF_task_gid () {0x234;}' unless defined(&AOFF_task_gid);
	eval 'sub ASIZ_task_gid () {0x4;}' unless defined(&ASIZ_task_gid);
	eval 'sub AOFF_task_egid () {0x238;}' unless defined(&AOFF_task_egid);
	eval 'sub ASIZ_task_egid () {0x4;}' unless defined(&ASIZ_task_egid);
	eval 'sub AOFF_task_sgid () {0x23c;}' unless defined(&AOFF_task_sgid);
	eval 'sub ASIZ_task_sgid () {0x4;}' unless defined(&ASIZ_task_sgid);
	eval 'sub AOFF_task_fsgid () {0x240;}' unless defined(&AOFF_task_fsgid);
	eval 'sub ASIZ_task_fsgid () {0x4;}' unless defined(&ASIZ_task_fsgid);
	eval 'sub AOFF_task_ngroups () {0x244;}' unless defined(&AOFF_task_ngroups);
	eval 'sub ASIZ_task_ngroups () {0x4;}' unless defined(&ASIZ_task_ngroups);
	eval 'sub AOFF_task_groups () {0x248;}' unless defined(&AOFF_task_groups);
	eval 'sub ASIZ_task_groups () {0x80;}' unless defined(&ASIZ_task_groups);
	eval 'sub AOFF_task_cap_effective () {0x2c8;}' unless defined(&AOFF_task_cap_effective);
	eval 'sub ASIZ_task_cap_effective () {0x4;}' unless defined(&ASIZ_task_cap_effective);
	eval 'sub AOFF_task_cap_inheritable () {0x2cc;}' unless defined(&AOFF_task_cap_inheritable);
	eval 'sub ASIZ_task_cap_inheritable () {0x4;}' unless defined(&ASIZ_task_cap_inheritable);
	eval 'sub AOFF_task_cap_permitted () {0x2d0;}' unless defined(&AOFF_task_cap_permitted);
	eval 'sub ASIZ_task_cap_permitted () {0x4;}' unless defined(&ASIZ_task_cap_permitted);
	eval 'sub AOFF_task_user () {0x2d8;}' unless defined(&AOFF_task_user);
	eval 'sub ASIZ_task_user () {0x8;}' unless defined(&ASIZ_task_user);
	eval 'sub AOFF_task_rlim () {0x2e0;}' unless defined(&AOFF_task_rlim);
	eval 'sub ASIZ_task_rlim () {0xb0;}' unless defined(&ASIZ_task_rlim);
	eval 'sub AOFF_task_used_math () {0x390;}' unless defined(&AOFF_task_used_math);
	eval 'sub ASIZ_task_used_math () {0x2;}' unless defined(&ASIZ_task_used_math);
	eval 'sub AOFF_task_comm () {0x392;}' unless defined(&AOFF_task_comm);
	eval 'sub ASIZ_task_comm () {0x10;}' unless defined(&ASIZ_task_comm);
	eval 'sub AOFF_task_link_count () {0x3a4;}' unless defined(&AOFF_task_link_count);
	eval 'sub ASIZ_task_link_count () {0x4;}' unless defined(&ASIZ_task_link_count);
	eval 'sub AOFF_task_total_link_count () {0x3a8;}' unless defined(&AOFF_task_total_link_count);
	eval 'sub ASIZ_task_total_link_count () {0x4;}' unless defined(&ASIZ_task_total_link_count);
	eval 'sub AOFF_task_tty () {0x3b0;}' unless defined(&AOFF_task_tty);
	eval 'sub ASIZ_task_tty () {0x8;}' unless defined(&ASIZ_task_tty);
	eval 'sub AOFF_task_locks () {0x3b8;}' unless defined(&AOFF_task_locks);
	eval 'sub ASIZ_task_locks () {0x4;}' unless defined(&ASIZ_task_locks);
	eval 'sub AOFF_task_semundo () {0x3c0;}' unless defined(&AOFF_task_semundo);
	eval 'sub ASIZ_task_semundo () {0x8;}' unless defined(&ASIZ_task_semundo);
	eval 'sub AOFF_task_semsleeping () {0x3c8;}' unless defined(&AOFF_task_semsleeping);
	eval 'sub ASIZ_task_semsleeping () {0x8;}' unless defined(&ASIZ_task_semsleeping);
	eval 'sub AOFF_task_thread () {0x3d0;}' unless defined(&AOFF_task_thread);
	eval 'sub ASIZ_task_thread () {0x480;}' unless defined(&ASIZ_task_thread);
	eval 'sub AOFF_task_fs () {0x850;}' unless defined(&AOFF_task_fs);
	eval 'sub ASIZ_task_fs () {0x8;}' unless defined(&ASIZ_task_fs);
	eval 'sub AOFF_task_files () {0x858;}' unless defined(&AOFF_task_files);
	eval 'sub ASIZ_task_files () {0x8;}' unless defined(&ASIZ_task_files);
	eval 'sub AOFF_task_namespace () {0x860;}' unless defined(&AOFF_task_namespace);
	eval 'sub ASIZ_task_namespace () {0x8;}' unless defined(&ASIZ_task_namespace);
	eval 'sub AOFF_task_sigmask_lock () {0x868;}' unless defined(&AOFF_task_sigmask_lock);
	eval 'sub ASIZ_task_sigmask_lock () {0x;}' unless defined(&ASIZ_task_sigmask_lock);
	eval 'sub AOFF_task_sig () {0x868;}' unless defined(&AOFF_task_sig);
	eval 'sub ASIZ_task_sig () {0x8;}' unless defined(&ASIZ_task_sig);
	eval 'sub AOFF_task_blocked () {0x870;}' unless defined(&AOFF_task_blocked);
	eval 'sub ASIZ_task_blocked () {0x8;}' unless defined(&ASIZ_task_blocked);
	eval 'sub AOFF_task_pending () {0x878;}' unless defined(&AOFF_task_pending);
	eval 'sub ASIZ_task_pending () {0x18;}' unless defined(&ASIZ_task_pending);
	eval 'sub AOFF_task_sas_ss_sp () {0x890;}' unless defined(&AOFF_task_sas_ss_sp);
	eval 'sub ASIZ_task_sas_ss_sp () {0x8;}' unless defined(&ASIZ_task_sas_ss_sp);
	eval 'sub AOFF_task_sas_ss_size () {0x898;}' unless defined(&AOFF_task_sas_ss_size);
	eval 'sub ASIZ_task_sas_ss_size () {0x8;}' unless defined(&ASIZ_task_sas_ss_size);
	eval 'sub AOFF_task_notifier () {0x8a0;}' unless defined(&AOFF_task_notifier);
	eval 'sub ASIZ_task_notifier () {0x8;}' unless defined(&ASIZ_task_notifier);
	eval 'sub AOFF_task_notifier_data () {0x8a8;}' unless defined(&AOFF_task_notifier_data);
	eval 'sub ASIZ_task_notifier_data () {0x8;}' unless defined(&ASIZ_task_notifier_data);
	eval 'sub AOFF_task_notifier_mask () {0x8b0;}' unless defined(&AOFF_task_notifier_mask);
	eval 'sub ASIZ_task_notifier_mask () {0x8;}' unless defined(&ASIZ_task_notifier_mask);
	eval 'sub AOFF_task_parent_exec_id () {0x8b8;}' unless defined(&AOFF_task_parent_exec_id);
	eval 'sub ASIZ_task_parent_exec_id () {0x4;}' unless defined(&ASIZ_task_parent_exec_id);
	eval 'sub AOFF_task_self_exec_id () {0x8bc;}' unless defined(&AOFF_task_self_exec_id);
	eval 'sub ASIZ_task_self_exec_id () {0x4;}' unless defined(&ASIZ_task_self_exec_id);
	eval 'sub AOFF_task_alloc_lock () {0x8c0;}' unless defined(&AOFF_task_alloc_lock);
	eval 'sub ASIZ_task_alloc_lock () {0x;}' unless defined(&ASIZ_task_alloc_lock);
	eval 'sub AOFF_task_journal_info () {0x8c0;}' unless defined(&AOFF_task_journal_info);
	eval 'sub ASIZ_task_journal_info () {0x8;}' unless defined(&ASIZ_task_journal_info);
	eval 'sub ASIZ_task () {0x8d0;}' unless defined(&ASIZ_task);
	eval 'sub AOFF_mm_mmap () {0x;}' unless defined(&AOFF_mm_mmap);
	eval 'sub ASIZ_mm_mmap () {0x8;}' unless defined(&ASIZ_mm_mmap);
	eval 'sub AOFF_mm_mm_rb () {0x8;}' unless defined(&AOFF_mm_mm_rb);
	eval 'sub ASIZ_mm_mm_rb () {0x8;}' unless defined(&ASIZ_mm_mm_rb);
	eval 'sub AOFF_mm_mmap_cache () {0x10;}' unless defined(&AOFF_mm_mmap_cache);
	eval 'sub ASIZ_mm_mmap_cache () {0x8;}' unless defined(&ASIZ_mm_mmap_cache);
	eval 'sub AOFF_mm_pgd () {0x18;}' unless defined(&AOFF_mm_pgd);
	eval 'sub ASIZ_mm_pgd () {0x8;}' unless defined(&ASIZ_mm_pgd);
	eval 'sub AOFF_mm_mm_users () {0x20;}' unless defined(&AOFF_mm_mm_users);
	eval 'sub ASIZ_mm_mm_users () {0x4;}' unless defined(&ASIZ_mm_mm_users);
	eval 'sub AOFF_mm_mm_count () {0x24;}' unless defined(&AOFF_mm_mm_count);
	eval 'sub ASIZ_mm_mm_count () {0x4;}' unless defined(&ASIZ_mm_mm_count);
	eval 'sub AOFF_mm_map_count () {0x28;}' unless defined(&AOFF_mm_map_count);
	eval 'sub ASIZ_mm_map_count () {0x4;}' unless defined(&ASIZ_mm_map_count);
	eval 'sub AOFF_mm_mmap_sem () {0x30;}' unless defined(&AOFF_mm_mmap_sem);
	eval 'sub ASIZ_mm_mmap_sem () {0x18;}' unless defined(&ASIZ_mm_mmap_sem);
	eval 'sub AOFF_mm_page_table_lock () {0x48;}' unless defined(&AOFF_mm_page_table_lock);
	eval 'sub ASIZ_mm_page_table_lock () {0x;}' unless defined(&ASIZ_mm_page_table_lock);
	eval 'sub AOFF_mm_mmlist () {0x48;}' unless defined(&AOFF_mm_mmlist);
	eval 'sub ASIZ_mm_mmlist () {0x10;}' unless defined(&ASIZ_mm_mmlist);
	eval 'sub AOFF_mm_start_code () {0x58;}' unless defined(&AOFF_mm_start_code);
	eval 'sub ASIZ_mm_start_code () {0x8;}' unless defined(&ASIZ_mm_start_code);
	eval 'sub AOFF_mm_end_code () {0x60;}' unless defined(&AOFF_mm_end_code);
	eval 'sub ASIZ_mm_end_code () {0x8;}' unless defined(&ASIZ_mm_end_code);
	eval 'sub AOFF_mm_start_data () {0x68;}' unless defined(&AOFF_mm_start_data);
	eval 'sub ASIZ_mm_start_data () {0x8;}' unless defined(&ASIZ_mm_start_data);
	eval 'sub AOFF_mm_end_data () {0x70;}' unless defined(&AOFF_mm_end_data);
	eval 'sub ASIZ_mm_end_data () {0x8;}' unless defined(&ASIZ_mm_end_data);
	eval 'sub AOFF_mm_start_brk () {0x78;}' unless defined(&AOFF_mm_start_brk);
	eval 'sub ASIZ_mm_start_brk () {0x8;}' unless defined(&ASIZ_mm_start_brk);
	eval 'sub AOFF_mm_brk () {0x80;}' unless defined(&AOFF_mm_brk);
	eval 'sub ASIZ_mm_brk () {0x8;}' unless defined(&ASIZ_mm_brk);
	eval 'sub AOFF_mm_start_stack () {0x88;}' unless defined(&AOFF_mm_start_stack);
	eval 'sub ASIZ_mm_start_stack () {0x8;}' unless defined(&ASIZ_mm_start_stack);
	eval 'sub AOFF_mm_arg_start () {0x90;}' unless defined(&AOFF_mm_arg_start);
	eval 'sub ASIZ_mm_arg_start () {0x8;}' unless defined(&ASIZ_mm_arg_start);
	eval 'sub AOFF_mm_arg_end () {0x98;}' unless defined(&AOFF_mm_arg_end);
	eval 'sub ASIZ_mm_arg_end () {0x8;}' unless defined(&ASIZ_mm_arg_end);
	eval 'sub AOFF_mm_env_start () {0xa0;}' unless defined(&AOFF_mm_env_start);
	eval 'sub ASIZ_mm_env_start () {0x8;}' unless defined(&ASIZ_mm_env_start);
	eval 'sub AOFF_mm_env_end () {0xa8;}' unless defined(&AOFF_mm_env_end);
	eval 'sub ASIZ_mm_env_end () {0x8;}' unless defined(&ASIZ_mm_env_end);
	eval 'sub AOFF_mm_rss () {0xb0;}' unless defined(&AOFF_mm_rss);
	eval 'sub ASIZ_mm_rss () {0x8;}' unless defined(&ASIZ_mm_rss);
	eval 'sub AOFF_mm_total_vm () {0xb8;}' unless defined(&AOFF_mm_total_vm);
	eval 'sub ASIZ_mm_total_vm () {0x8;}' unless defined(&ASIZ_mm_total_vm);
	eval 'sub AOFF_mm_locked_vm () {0xc0;}' unless defined(&AOFF_mm_locked_vm);
	eval 'sub ASIZ_mm_locked_vm () {0x8;}' unless defined(&ASIZ_mm_locked_vm);
	eval 'sub AOFF_mm_def_flags () {0xc8;}' unless defined(&AOFF_mm_def_flags);
	eval 'sub ASIZ_mm_def_flags () {0x8;}' unless defined(&ASIZ_mm_def_flags);
	eval 'sub AOFF_mm_cpu_vm_mask () {0xd0;}' unless defined(&AOFF_mm_cpu_vm_mask);
	eval 'sub ASIZ_mm_cpu_vm_mask () {0x8;}' unless defined(&ASIZ_mm_cpu_vm_mask);
	eval 'sub AOFF_mm_swap_address () {0xd8;}' unless defined(&AOFF_mm_swap_address);
	eval 'sub ASIZ_mm_swap_address () {0x8;}' unless defined(&ASIZ_mm_swap_address);
	eval 'sub AOFF_mm_context () {0xe8;}' unless defined(&AOFF_mm_context);
	eval 'sub ASIZ_mm_context () {0x8;}' unless defined(&ASIZ_mm_context);
	eval 'sub ASIZ_mm () {0xf0;}' unless defined(&ASIZ_mm);
	eval 'sub AOFF_thread_ksp () {0x;}' unless defined(&AOFF_thread_ksp);
	eval 'sub ASIZ_thread_ksp () {0x8;}' unless defined(&ASIZ_thread_ksp);
	eval 'sub AOFF_thread_wstate () {0x8;}' unless defined(&AOFF_thread_wstate);
	eval 'sub ASIZ_thread_wstate () {0x1;}' unless defined(&ASIZ_thread_wstate);
	eval 'sub AOFF_thread_cwp () {0x9;}' unless defined(&AOFF_thread_cwp);
	eval 'sub ASIZ_thread_cwp () {0x1;}' unless defined(&ASIZ_thread_cwp);
	eval 'sub AOFF_thread_flags () {0xa;}' unless defined(&AOFF_thread_flags);
	eval 'sub ASIZ_thread_flags () {0x1;}' unless defined(&ASIZ_thread_flags);
	eval 'sub AOFF_thread_current_ds () {0xb;}' unless defined(&AOFF_thread_current_ds);
	eval 'sub ASIZ_thread_current_ds () {0x1;}' unless defined(&ASIZ_thread_current_ds);
	eval 'sub AOFF_thread_w_saved () {0xc;}' unless defined(&AOFF_thread_w_saved);
	eval 'sub ASIZ_thread_w_saved () {0x1;}' unless defined(&ASIZ_thread_w_saved);
	eval 'sub AOFF_thread_fpdepth () {0xd;}' unless defined(&AOFF_thread_fpdepth);
	eval 'sub ASIZ_thread_fpdepth () {0x1;}' unless defined(&ASIZ_thread_fpdepth);
	eval 'sub AOFF_thread_fault_code () {0xe;}' unless defined(&AOFF_thread_fault_code);
	eval 'sub ASIZ_thread_fault_code () {0x1;}' unless defined(&ASIZ_thread_fault_code);
	eval 'sub AOFF_thread_use_blkcommit () {0xf;}' unless defined(&AOFF_thread_use_blkcommit);
	eval 'sub ASIZ_thread_use_blkcommit () {0x1;}' unless defined(&ASIZ_thread_use_blkcommit);
	eval 'sub AOFF_thread_fault_address () {0x10;}' unless defined(&AOFF_thread_fault_address);
	eval 'sub ASIZ_thread_fault_address () {0x8;}' unless defined(&ASIZ_thread_fault_address);
	eval 'sub AOFF_thread_fpsaved () {0x18;}' unless defined(&AOFF_thread_fpsaved);
	eval 'sub ASIZ_thread_fpsaved () {0x7;}' unless defined(&ASIZ_thread_fpsaved);
	eval 'sub AOFF_thread___pad2 () {0x1f;}' unless defined(&AOFF_thread___pad2);
	eval 'sub ASIZ_thread___pad2 () {0x1;}' unless defined(&ASIZ_thread___pad2);
	eval 'sub AOFF_thread_kregs () {0x20;}' unless defined(&AOFF_thread_kregs);
	eval 'sub ASIZ_thread_kregs () {0x8;}' unless defined(&ASIZ_thread_kregs);
	eval 'sub AOFF_thread_utraps () {0x28;}' unless defined(&AOFF_thread_utraps);
	eval 'sub ASIZ_thread_utraps () {0x8;}' unless defined(&ASIZ_thread_utraps);
	eval 'sub AOFF_thread_gsr () {0x30;}' unless defined(&AOFF_thread_gsr);
	eval 'sub ASIZ_thread_gsr () {0x38;}' unless defined(&ASIZ_thread_gsr);
	eval 'sub AOFF_thread_xfsr () {0x68;}' unless defined(&AOFF_thread_xfsr);
	eval 'sub ASIZ_thread_xfsr () {0x38;}' unless defined(&ASIZ_thread_xfsr);
	eval 'sub AOFF_thread_reg_window () {0xa0;}' unless defined(&AOFF_thread_reg_window);
	eval 'sub ASIZ_thread_reg_window () {0x380;}' unless defined(&ASIZ_thread_reg_window);
	eval 'sub AOFF_thread_rwbuf_stkptrs () {0x420;}' unless defined(&AOFF_thread_rwbuf_stkptrs);
	eval 'sub ASIZ_thread_rwbuf_stkptrs () {0x38;}' unless defined(&ASIZ_thread_rwbuf_stkptrs);
	eval 'sub AOFF_thread_user_cntd0 () {0x458;}' unless defined(&AOFF_thread_user_cntd0);
	eval 'sub ASIZ_thread_user_cntd0 () {0x8;}' unless defined(&ASIZ_thread_user_cntd0);
	eval 'sub AOFF_thread_user_cntd1 () {0x460;}' unless defined(&AOFF_thread_user_cntd1);
	eval 'sub ASIZ_thread_user_cntd1 () {0x8;}' unless defined(&ASIZ_thread_user_cntd1);
	eval 'sub AOFF_thread_kernel_cntd0 () {0x468;}' unless defined(&AOFF_thread_kernel_cntd0);
	eval 'sub ASIZ_thread_kernel_cntd0 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd0);
	eval 'sub AOFF_thread_kernel_cntd1 () {0x470;}' unless defined(&AOFF_thread_kernel_cntd1);
	eval 'sub ASIZ_thread_kernel_cntd1 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd1);
	eval 'sub AOFF_thread_pcr_reg () {0x478;}' unless defined(&AOFF_thread_pcr_reg);
	eval 'sub ASIZ_thread_pcr_reg () {0x8;}' unless defined(&ASIZ_thread_pcr_reg);
	eval 'sub ASIZ_thread () {0x480;}' unless defined(&ASIZ_thread);
    } else {
	unless(defined(&CONFIG_DEBUG_SPINLOCK)) {
	    eval 'sub AOFF_task_state () {0x;}' unless defined(&AOFF_task_state);
	    eval 'sub ASIZ_task_state () {0x8;}' unless defined(&ASIZ_task_state);
	    eval 'sub AOFF_task_flags () {0x8;}' unless defined(&AOFF_task_flags);
	    eval 'sub ASIZ_task_flags () {0x8;}' unless defined(&ASIZ_task_flags);
	    eval 'sub AOFF_task_sigpending () {0x10;}' unless defined(&AOFF_task_sigpending);
	    eval 'sub ASIZ_task_sigpending () {0x4;}' unless defined(&ASIZ_task_sigpending);
	    eval 'sub AOFF_task_addr_limit () {0x14;}' unless defined(&AOFF_task_addr_limit);
	    eval 'sub ASIZ_task_addr_limit () {0x1;}' unless defined(&ASIZ_task_addr_limit);
	    eval 'sub AOFF_task_exec_domain () {0x18;}' unless defined(&AOFF_task_exec_domain);
	    eval 'sub ASIZ_task_exec_domain () {0x8;}' unless defined(&ASIZ_task_exec_domain);
	    eval 'sub AOFF_task_need_resched () {0x20;}' unless defined(&AOFF_task_need_resched);
	    eval 'sub ASIZ_task_need_resched () {0x8;}' unless defined(&ASIZ_task_need_resched);
	    eval 'sub AOFF_task_ptrace () {0x28;}' unless defined(&AOFF_task_ptrace);
	    eval 'sub ASIZ_task_ptrace () {0x8;}' unless defined(&ASIZ_task_ptrace);
	    eval 'sub AOFF_task_lock_depth () {0x30;}' unless defined(&AOFF_task_lock_depth);
	    eval 'sub ASIZ_task_lock_depth () {0x4;}' unless defined(&ASIZ_task_lock_depth);
	    eval 'sub AOFF_task_counter () {0x38;}' unless defined(&AOFF_task_counter);
	    eval 'sub ASIZ_task_counter () {0x8;}' unless defined(&ASIZ_task_counter);
	    eval 'sub AOFF_task_nice () {0x40;}' unless defined(&AOFF_task_nice);
	    eval 'sub ASIZ_task_nice () {0x8;}' unless defined(&ASIZ_task_nice);
	    eval 'sub AOFF_task_policy () {0x48;}' unless defined(&AOFF_task_policy);
	    eval 'sub ASIZ_task_policy () {0x8;}' unless defined(&ASIZ_task_policy);
	    eval 'sub AOFF_task_mm () {0x50;}' unless defined(&AOFF_task_mm);
	    eval 'sub ASIZ_task_mm () {0x8;}' unless defined(&ASIZ_task_mm);
	    eval 'sub AOFF_task_processor () {0x58;}' unless defined(&AOFF_task_processor);
	    eval 'sub ASIZ_task_processor () {0x4;}' unless defined(&ASIZ_task_processor);
	    eval 'sub AOFF_task_cpus_runnable () {0x60;}' unless defined(&AOFF_task_cpus_runnable);
	    eval 'sub ASIZ_task_cpus_runnable () {0x8;}' unless defined(&ASIZ_task_cpus_runnable);
	    eval 'sub AOFF_task_cpus_allowed () {0x68;}' unless defined(&AOFF_task_cpus_allowed);
	    eval 'sub ASIZ_task_cpus_allowed () {0x8;}' unless defined(&ASIZ_task_cpus_allowed);
	    eval 'sub AOFF_task_run_list () {0x70;}' unless defined(&AOFF_task_run_list);
	    eval 'sub ASIZ_task_run_list () {0x10;}' unless defined(&ASIZ_task_run_list);
	    eval 'sub AOFF_task_sleep_time () {0x80;}' unless defined(&AOFF_task_sleep_time);
	    eval 'sub ASIZ_task_sleep_time () {0x8;}' unless defined(&ASIZ_task_sleep_time);
	    eval 'sub AOFF_task_next_task () {0x88;}' unless defined(&AOFF_task_next_task);
	    eval 'sub ASIZ_task_next_task () {0x8;}' unless defined(&ASIZ_task_next_task);
	    eval 'sub AOFF_task_prev_task () {0x90;}' unless defined(&AOFF_task_prev_task);
	    eval 'sub ASIZ_task_prev_task () {0x8;}' unless defined(&ASIZ_task_prev_task);
	    eval 'sub AOFF_task_active_mm () {0x98;}' unless defined(&AOFF_task_active_mm);
	    eval 'sub ASIZ_task_active_mm () {0x8;}' unless defined(&ASIZ_task_active_mm);
	    eval 'sub AOFF_task_local_pages () {0xa0;}' unless defined(&AOFF_task_local_pages);
	    eval 'sub ASIZ_task_local_pages () {0x10;}' unless defined(&ASIZ_task_local_pages);
	    eval 'sub AOFF_task_allocation_order () {0xb0;}' unless defined(&AOFF_task_allocation_order);
	    eval 'sub ASIZ_task_allocation_order () {0x4;}' unless defined(&ASIZ_task_allocation_order);
	    eval 'sub AOFF_task_nr_local_pages () {0xb4;}' unless defined(&AOFF_task_nr_local_pages);
	    eval 'sub ASIZ_task_nr_local_pages () {0x4;}' unless defined(&ASIZ_task_nr_local_pages);
	    eval 'sub AOFF_task_binfmt () {0xb8;}' unless defined(&AOFF_task_binfmt);
	    eval 'sub ASIZ_task_binfmt () {0x8;}' unless defined(&ASIZ_task_binfmt);
	    eval 'sub AOFF_task_exit_code () {0xc0;}' unless defined(&AOFF_task_exit_code);
	    eval 'sub ASIZ_task_exit_code () {0x4;}' unless defined(&ASIZ_task_exit_code);
	    eval 'sub AOFF_task_exit_signal () {0xc4;}' unless defined(&AOFF_task_exit_signal);
	    eval 'sub ASIZ_task_exit_signal () {0x4;}' unless defined(&ASIZ_task_exit_signal);
	    eval 'sub AOFF_task_pdeath_signal () {0xc8;}' unless defined(&AOFF_task_pdeath_signal);
	    eval 'sub ASIZ_task_pdeath_signal () {0x4;}' unless defined(&ASIZ_task_pdeath_signal);
	    eval 'sub AOFF_task_personality () {0xd0;}' unless defined(&AOFF_task_personality);
	    eval 'sub ASIZ_task_personality () {0x8;}' unless defined(&ASIZ_task_personality);
	    eval 'sub AOFF_task_pid () {0xdc;}' unless defined(&AOFF_task_pid);
	    eval 'sub ASIZ_task_pid () {0x4;}' unless defined(&ASIZ_task_pid);
	    eval 'sub AOFF_task_pgrp () {0xe0;}' unless defined(&AOFF_task_pgrp);
	    eval 'sub ASIZ_task_pgrp () {0x4;}' unless defined(&ASIZ_task_pgrp);
	    eval 'sub AOFF_task_tty_old_pgrp () {0xe4;}' unless defined(&AOFF_task_tty_old_pgrp);
	    eval 'sub ASIZ_task_tty_old_pgrp () {0x4;}' unless defined(&ASIZ_task_tty_old_pgrp);
	    eval 'sub AOFF_task_session () {0xe8;}' unless defined(&AOFF_task_session);
	    eval 'sub ASIZ_task_session () {0x4;}' unless defined(&ASIZ_task_session);
	    eval 'sub AOFF_task_tgid () {0xec;}' unless defined(&AOFF_task_tgid);
	    eval 'sub ASIZ_task_tgid () {0x4;}' unless defined(&ASIZ_task_tgid);
	    eval 'sub AOFF_task_leader () {0xf0;}' unless defined(&AOFF_task_leader);
	    eval 'sub ASIZ_task_leader () {0x4;}' unless defined(&ASIZ_task_leader);
	    eval 'sub AOFF_task_p_opptr () {0xf8;}' unless defined(&AOFF_task_p_opptr);
	    eval 'sub ASIZ_task_p_opptr () {0x8;}' unless defined(&ASIZ_task_p_opptr);
	    eval 'sub AOFF_task_p_pptr () {0x100;}' unless defined(&AOFF_task_p_pptr);
	    eval 'sub ASIZ_task_p_pptr () {0x8;}' unless defined(&ASIZ_task_p_pptr);
	    eval 'sub AOFF_task_p_cptr () {0x108;}' unless defined(&AOFF_task_p_cptr);
	    eval 'sub ASIZ_task_p_cptr () {0x8;}' unless defined(&ASIZ_task_p_cptr);
	    eval 'sub AOFF_task_p_ysptr () {0x110;}' unless defined(&AOFF_task_p_ysptr);
	    eval 'sub ASIZ_task_p_ysptr () {0x8;}' unless defined(&ASIZ_task_p_ysptr);
	    eval 'sub AOFF_task_p_osptr () {0x118;}' unless defined(&AOFF_task_p_osptr);
	    eval 'sub ASIZ_task_p_osptr () {0x8;}' unless defined(&ASIZ_task_p_osptr);
	    eval 'sub AOFF_task_thread_group () {0x120;}' unless defined(&AOFF_task_thread_group);
	    eval 'sub ASIZ_task_thread_group () {0x10;}' unless defined(&ASIZ_task_thread_group);
	    eval 'sub AOFF_task_pidhash_next () {0x130;}' unless defined(&AOFF_task_pidhash_next);
	    eval 'sub ASIZ_task_pidhash_next () {0x8;}' unless defined(&ASIZ_task_pidhash_next);
	    eval 'sub AOFF_task_pidhash_pprev () {0x138;}' unless defined(&AOFF_task_pidhash_pprev);
	    eval 'sub ASIZ_task_pidhash_pprev () {0x8;}' unless defined(&ASIZ_task_pidhash_pprev);
	    eval 'sub AOFF_task_wait_chldexit () {0x140;}' unless defined(&AOFF_task_wait_chldexit);
	    eval 'sub ASIZ_task_wait_chldexit () {0x18;}' unless defined(&ASIZ_task_wait_chldexit);
	    eval 'sub AOFF_task_vfork_done () {0x158;}' unless defined(&AOFF_task_vfork_done);
	    eval 'sub ASIZ_task_vfork_done () {0x8;}' unless defined(&ASIZ_task_vfork_done);
	    eval 'sub AOFF_task_rt_priority () {0x160;}' unless defined(&AOFF_task_rt_priority);
	    eval 'sub ASIZ_task_rt_priority () {0x8;}' unless defined(&ASIZ_task_rt_priority);
	    eval 'sub AOFF_task_it_real_value () {0x168;}' unless defined(&AOFF_task_it_real_value);
	    eval 'sub ASIZ_task_it_real_value () {0x8;}' unless defined(&ASIZ_task_it_real_value);
	    eval 'sub AOFF_task_it_prof_value () {0x170;}' unless defined(&AOFF_task_it_prof_value);
	    eval 'sub ASIZ_task_it_prof_value () {0x8;}' unless defined(&ASIZ_task_it_prof_value);
	    eval 'sub AOFF_task_it_virt_value () {0x178;}' unless defined(&AOFF_task_it_virt_value);
	    eval 'sub ASIZ_task_it_virt_value () {0x8;}' unless defined(&ASIZ_task_it_virt_value);
	    eval 'sub AOFF_task_it_real_incr () {0x180;}' unless defined(&AOFF_task_it_real_incr);
	    eval 'sub ASIZ_task_it_real_incr () {0x8;}' unless defined(&ASIZ_task_it_real_incr);
	    eval 'sub AOFF_task_it_prof_incr () {0x188;}' unless defined(&AOFF_task_it_prof_incr);
	    eval 'sub ASIZ_task_it_prof_incr () {0x8;}' unless defined(&ASIZ_task_it_prof_incr);
	    eval 'sub AOFF_task_it_virt_incr () {0x190;}' unless defined(&AOFF_task_it_virt_incr);
	    eval 'sub ASIZ_task_it_virt_incr () {0x8;}' unless defined(&ASIZ_task_it_virt_incr);
	    eval 'sub AOFF_task_real_timer () {0x198;}' unless defined(&AOFF_task_real_timer);
	    eval 'sub ASIZ_task_real_timer () {0x28;}' unless defined(&ASIZ_task_real_timer);
	    eval 'sub AOFF_task_times () {0x1c0;}' unless defined(&AOFF_task_times);
	    eval 'sub ASIZ_task_times () {0x20;}' unless defined(&ASIZ_task_times);
	    eval 'sub AOFF_task_start_time () {0x1e0;}' unless defined(&AOFF_task_start_time);
	    eval 'sub ASIZ_task_start_time () {0x8;}' unless defined(&ASIZ_task_start_time);
	    eval 'sub AOFF_task_per_cpu_utime () {0x1e8;}' unless defined(&AOFF_task_per_cpu_utime);
	    eval 'sub ASIZ_task_per_cpu_utime () {0x100;}' unless defined(&ASIZ_task_per_cpu_utime);
	    eval 'sub AOFF_task_min_flt () {0x3e8;}' unless defined(&AOFF_task_min_flt);
	    eval 'sub ASIZ_task_min_flt () {0x8;}' unless defined(&ASIZ_task_min_flt);
	    eval 'sub AOFF_task_maj_flt () {0x3f0;}' unless defined(&AOFF_task_maj_flt);
	    eval 'sub ASIZ_task_maj_flt () {0x8;}' unless defined(&ASIZ_task_maj_flt);
	    eval 'sub AOFF_task_nswap () {0x3f8;}' unless defined(&AOFF_task_nswap);
	    eval 'sub ASIZ_task_nswap () {0x8;}' unless defined(&ASIZ_task_nswap);
	    eval 'sub AOFF_task_cmin_flt () {0x400;}' unless defined(&AOFF_task_cmin_flt);
	    eval 'sub ASIZ_task_cmin_flt () {0x8;}' unless defined(&ASIZ_task_cmin_flt);
	    eval 'sub AOFF_task_cmaj_flt () {0x408;}' unless defined(&AOFF_task_cmaj_flt);
	    eval 'sub ASIZ_task_cmaj_flt () {0x8;}' unless defined(&ASIZ_task_cmaj_flt);
	    eval 'sub AOFF_task_cnswap () {0x410;}' unless defined(&AOFF_task_cnswap);
	    eval 'sub ASIZ_task_cnswap () {0x8;}' unless defined(&ASIZ_task_cnswap);
	    eval 'sub AOFF_task_uid () {0x41c;}' unless defined(&AOFF_task_uid);
	    eval 'sub ASIZ_task_uid () {0x4;}' unless defined(&ASIZ_task_uid);
	    eval 'sub AOFF_task_euid () {0x420;}' unless defined(&AOFF_task_euid);
	    eval 'sub ASIZ_task_euid () {0x4;}' unless defined(&ASIZ_task_euid);
	    eval 'sub AOFF_task_suid () {0x424;}' unless defined(&AOFF_task_suid);
	    eval 'sub ASIZ_task_suid () {0x4;}' unless defined(&ASIZ_task_suid);
	    eval 'sub AOFF_task_fsuid () {0x428;}' unless defined(&AOFF_task_fsuid);
	    eval 'sub ASIZ_task_fsuid () {0x4;}' unless defined(&ASIZ_task_fsuid);
	    eval 'sub AOFF_task_gid () {0x42c;}' unless defined(&AOFF_task_gid);
	    eval 'sub ASIZ_task_gid () {0x4;}' unless defined(&ASIZ_task_gid);
	    eval 'sub AOFF_task_egid () {0x430;}' unless defined(&AOFF_task_egid);
	    eval 'sub ASIZ_task_egid () {0x4;}' unless defined(&ASIZ_task_egid);
	    eval 'sub AOFF_task_sgid () {0x434;}' unless defined(&AOFF_task_sgid);
	    eval 'sub ASIZ_task_sgid () {0x4;}' unless defined(&ASIZ_task_sgid);
	    eval 'sub AOFF_task_fsgid () {0x438;}' unless defined(&AOFF_task_fsgid);
	    eval 'sub ASIZ_task_fsgid () {0x4;}' unless defined(&ASIZ_task_fsgid);
	    eval 'sub AOFF_task_ngroups () {0x43c;}' unless defined(&AOFF_task_ngroups);
	    eval 'sub ASIZ_task_ngroups () {0x4;}' unless defined(&ASIZ_task_ngroups);
	    eval 'sub AOFF_task_groups () {0x440;}' unless defined(&AOFF_task_groups);
	    eval 'sub ASIZ_task_groups () {0x80;}' unless defined(&ASIZ_task_groups);
	    eval 'sub AOFF_task_cap_effective () {0x4c0;}' unless defined(&AOFF_task_cap_effective);
	    eval 'sub ASIZ_task_cap_effective () {0x4;}' unless defined(&ASIZ_task_cap_effective);
	    eval 'sub AOFF_task_cap_inheritable () {0x4c4;}' unless defined(&AOFF_task_cap_inheritable);
	    eval 'sub ASIZ_task_cap_inheritable () {0x4;}' unless defined(&ASIZ_task_cap_inheritable);
	    eval 'sub AOFF_task_cap_permitted () {0x4c8;}' unless defined(&AOFF_task_cap_permitted);
	    eval 'sub ASIZ_task_cap_permitted () {0x4;}' unless defined(&ASIZ_task_cap_permitted);
	    eval 'sub AOFF_task_user () {0x4d0;}' unless defined(&AOFF_task_user);
	    eval 'sub ASIZ_task_user () {0x8;}' unless defined(&ASIZ_task_user);
	    eval 'sub AOFF_task_rlim () {0x4d8;}' unless defined(&AOFF_task_rlim);
	    eval 'sub ASIZ_task_rlim () {0xb0;}' unless defined(&ASIZ_task_rlim);
	    eval 'sub AOFF_task_used_math () {0x588;}' unless defined(&AOFF_task_used_math);
	    eval 'sub ASIZ_task_used_math () {0x2;}' unless defined(&ASIZ_task_used_math);
	    eval 'sub AOFF_task_comm () {0x58a;}' unless defined(&AOFF_task_comm);
	    eval 'sub ASIZ_task_comm () {0x10;}' unless defined(&ASIZ_task_comm);
	    eval 'sub AOFF_task_link_count () {0x59c;}' unless defined(&AOFF_task_link_count);
	    eval 'sub ASIZ_task_link_count () {0x4;}' unless defined(&ASIZ_task_link_count);
	    eval 'sub AOFF_task_total_link_count () {0x5a0;}' unless defined(&AOFF_task_total_link_count);
	    eval 'sub ASIZ_task_total_link_count () {0x4;}' unless defined(&ASIZ_task_total_link_count);
	    eval 'sub AOFF_task_tty () {0x5a8;}' unless defined(&AOFF_task_tty);
	    eval 'sub ASIZ_task_tty () {0x8;}' unless defined(&ASIZ_task_tty);
	    eval 'sub AOFF_task_locks () {0x5b0;}' unless defined(&AOFF_task_locks);
	    eval 'sub ASIZ_task_locks () {0x4;}' unless defined(&ASIZ_task_locks);
	    eval 'sub AOFF_task_semundo () {0x5b8;}' unless defined(&AOFF_task_semundo);
	    eval 'sub ASIZ_task_semundo () {0x8;}' unless defined(&ASIZ_task_semundo);
	    eval 'sub AOFF_task_semsleeping () {0x5c0;}' unless defined(&AOFF_task_semsleeping);
	    eval 'sub ASIZ_task_semsleeping () {0x8;}' unless defined(&ASIZ_task_semsleeping);
	    eval 'sub AOFF_task_thread () {0x5d0;}' unless defined(&AOFF_task_thread);
	    eval 'sub ASIZ_task_thread () {0x480;}' unless defined(&ASIZ_task_thread);
	    eval 'sub AOFF_task_fs () {0xa50;}' unless defined(&AOFF_task_fs);
	    eval 'sub ASIZ_task_fs () {0x8;}' unless defined(&ASIZ_task_fs);
	    eval 'sub AOFF_task_files () {0xa58;}' unless defined(&AOFF_task_files);
	    eval 'sub ASIZ_task_files () {0x8;}' unless defined(&ASIZ_task_files);
	    eval 'sub AOFF_task_namespace () {0xa60;}' unless defined(&AOFF_task_namespace);
	    eval 'sub ASIZ_task_namespace () {0x8;}' unless defined(&ASIZ_task_namespace);
	    eval 'sub AOFF_task_sigmask_lock () {0xa68;}' unless defined(&AOFF_task_sigmask_lock);
	    eval 'sub ASIZ_task_sigmask_lock () {0x1;}' unless defined(&ASIZ_task_sigmask_lock);
	    eval 'sub AOFF_task_sig () {0xa70;}' unless defined(&AOFF_task_sig);
	    eval 'sub ASIZ_task_sig () {0x8;}' unless defined(&ASIZ_task_sig);
	    eval 'sub AOFF_task_blocked () {0xa78;}' unless defined(&AOFF_task_blocked);
	    eval 'sub ASIZ_task_blocked () {0x8;}' unless defined(&ASIZ_task_blocked);
	    eval 'sub AOFF_task_pending () {0xa80;}' unless defined(&AOFF_task_pending);
	    eval 'sub ASIZ_task_pending () {0x18;}' unless defined(&ASIZ_task_pending);
	    eval 'sub AOFF_task_sas_ss_sp () {0xa98;}' unless defined(&AOFF_task_sas_ss_sp);
	    eval 'sub ASIZ_task_sas_ss_sp () {0x8;}' unless defined(&ASIZ_task_sas_ss_sp);
	    eval 'sub AOFF_task_sas_ss_size () {0xaa0;}' unless defined(&AOFF_task_sas_ss_size);
	    eval 'sub ASIZ_task_sas_ss_size () {0x8;}' unless defined(&ASIZ_task_sas_ss_size);
	    eval 'sub AOFF_task_notifier () {0xaa8;}' unless defined(&AOFF_task_notifier);
	    eval 'sub ASIZ_task_notifier () {0x8;}' unless defined(&ASIZ_task_notifier);
	    eval 'sub AOFF_task_notifier_data () {0xab0;}' unless defined(&AOFF_task_notifier_data);
	    eval 'sub ASIZ_task_notifier_data () {0x8;}' unless defined(&ASIZ_task_notifier_data);
	    eval 'sub AOFF_task_notifier_mask () {0xab8;}' unless defined(&AOFF_task_notifier_mask);
	    eval 'sub ASIZ_task_notifier_mask () {0x8;}' unless defined(&ASIZ_task_notifier_mask);
	    eval 'sub AOFF_task_parent_exec_id () {0xac0;}' unless defined(&AOFF_task_parent_exec_id);
	    eval 'sub ASIZ_task_parent_exec_id () {0x4;}' unless defined(&ASIZ_task_parent_exec_id);
	    eval 'sub AOFF_task_self_exec_id () {0xac4;}' unless defined(&AOFF_task_self_exec_id);
	    eval 'sub ASIZ_task_self_exec_id () {0x4;}' unless defined(&ASIZ_task_self_exec_id);
	    eval 'sub AOFF_task_alloc_lock () {0xac8;}' unless defined(&AOFF_task_alloc_lock);
	    eval 'sub ASIZ_task_alloc_lock () {0x1;}' unless defined(&ASIZ_task_alloc_lock);
	    eval 'sub AOFF_task_journal_info () {0xad0;}' unless defined(&AOFF_task_journal_info);
	    eval 'sub ASIZ_task_journal_info () {0x8;}' unless defined(&ASIZ_task_journal_info);
	    eval 'sub ASIZ_task () {0xae0;}' unless defined(&ASIZ_task);
	    eval 'sub AOFF_mm_mmap () {0x;}' unless defined(&AOFF_mm_mmap);
	    eval 'sub ASIZ_mm_mmap () {0x8;}' unless defined(&ASIZ_mm_mmap);
	    eval 'sub AOFF_mm_mm_rb () {0x8;}' unless defined(&AOFF_mm_mm_rb);
	    eval 'sub ASIZ_mm_mm_rb () {0x8;}' unless defined(&ASIZ_mm_mm_rb);
	    eval 'sub AOFF_mm_mmap_cache () {0x10;}' unless defined(&AOFF_mm_mmap_cache);
	    eval 'sub ASIZ_mm_mmap_cache () {0x8;}' unless defined(&ASIZ_mm_mmap_cache);
	    eval 'sub AOFF_mm_pgd () {0x18;}' unless defined(&AOFF_mm_pgd);
	    eval 'sub ASIZ_mm_pgd () {0x8;}' unless defined(&ASIZ_mm_pgd);
	    eval 'sub AOFF_mm_mm_users () {0x20;}' unless defined(&AOFF_mm_mm_users);
	    eval 'sub ASIZ_mm_mm_users () {0x4;}' unless defined(&ASIZ_mm_mm_users);
	    eval 'sub AOFF_mm_mm_count () {0x24;}' unless defined(&AOFF_mm_mm_count);
	    eval 'sub ASIZ_mm_mm_count () {0x4;}' unless defined(&ASIZ_mm_mm_count);
	    eval 'sub AOFF_mm_map_count () {0x28;}' unless defined(&AOFF_mm_map_count);
	    eval 'sub ASIZ_mm_map_count () {0x4;}' unless defined(&ASIZ_mm_map_count);
	    eval 'sub AOFF_mm_mmap_sem () {0x30;}' unless defined(&AOFF_mm_mmap_sem);
	    eval 'sub ASIZ_mm_mmap_sem () {0x18;}' unless defined(&ASIZ_mm_mmap_sem);
	    eval 'sub AOFF_mm_page_table_lock () {0x48;}' unless defined(&AOFF_mm_page_table_lock);
	    eval 'sub ASIZ_mm_page_table_lock () {0x1;}' unless defined(&ASIZ_mm_page_table_lock);
	    eval 'sub AOFF_mm_mmlist () {0x50;}' unless defined(&AOFF_mm_mmlist);
	    eval 'sub ASIZ_mm_mmlist () {0x10;}' unless defined(&ASIZ_mm_mmlist);
	    eval 'sub AOFF_mm_start_code () {0x60;}' unless defined(&AOFF_mm_start_code);
	    eval 'sub ASIZ_mm_start_code () {0x8;}' unless defined(&ASIZ_mm_start_code);
	    eval 'sub AOFF_mm_end_code () {0x68;}' unless defined(&AOFF_mm_end_code);
	    eval 'sub ASIZ_mm_end_code () {0x8;}' unless defined(&ASIZ_mm_end_code);
	    eval 'sub AOFF_mm_start_data () {0x70;}' unless defined(&AOFF_mm_start_data);
	    eval 'sub ASIZ_mm_start_data () {0x8;}' unless defined(&ASIZ_mm_start_data);
	    eval 'sub AOFF_mm_end_data () {0x78;}' unless defined(&AOFF_mm_end_data);
	    eval 'sub ASIZ_mm_end_data () {0x8;}' unless defined(&ASIZ_mm_end_data);
	    eval 'sub AOFF_mm_start_brk () {0x80;}' unless defined(&AOFF_mm_start_brk);
	    eval 'sub ASIZ_mm_start_brk () {0x8;}' unless defined(&ASIZ_mm_start_brk);
	    eval 'sub AOFF_mm_brk () {0x88;}' unless defined(&AOFF_mm_brk);
	    eval 'sub ASIZ_mm_brk () {0x8;}' unless defined(&ASIZ_mm_brk);
	    eval 'sub AOFF_mm_start_stack () {0x90;}' unless defined(&AOFF_mm_start_stack);
	    eval 'sub ASIZ_mm_start_stack () {0x8;}' unless defined(&ASIZ_mm_start_stack);
	    eval 'sub AOFF_mm_arg_start () {0x98;}' unless defined(&AOFF_mm_arg_start);
	    eval 'sub ASIZ_mm_arg_start () {0x8;}' unless defined(&ASIZ_mm_arg_start);
	    eval 'sub AOFF_mm_arg_end () {0xa0;}' unless defined(&AOFF_mm_arg_end);
	    eval 'sub ASIZ_mm_arg_end () {0x8;}' unless defined(&ASIZ_mm_arg_end);
	    eval 'sub AOFF_mm_env_start () {0xa8;}' unless defined(&AOFF_mm_env_start);
	    eval 'sub ASIZ_mm_env_start () {0x8;}' unless defined(&ASIZ_mm_env_start);
	    eval 'sub AOFF_mm_env_end () {0xb0;}' unless defined(&AOFF_mm_env_end);
	    eval 'sub ASIZ_mm_env_end () {0x8;}' unless defined(&ASIZ_mm_env_end);
	    eval 'sub AOFF_mm_rss () {0xb8;}' unless defined(&AOFF_mm_rss);
	    eval 'sub ASIZ_mm_rss () {0x8;}' unless defined(&ASIZ_mm_rss);
	    eval 'sub AOFF_mm_total_vm () {0xc0;}' unless defined(&AOFF_mm_total_vm);
	    eval 'sub ASIZ_mm_total_vm () {0x8;}' unless defined(&ASIZ_mm_total_vm);
	    eval 'sub AOFF_mm_locked_vm () {0xc8;}' unless defined(&AOFF_mm_locked_vm);
	    eval 'sub ASIZ_mm_locked_vm () {0x8;}' unless defined(&ASIZ_mm_locked_vm);
	    eval 'sub AOFF_mm_def_flags () {0xd0;}' unless defined(&AOFF_mm_def_flags);
	    eval 'sub ASIZ_mm_def_flags () {0x8;}' unless defined(&ASIZ_mm_def_flags);
	    eval 'sub AOFF_mm_cpu_vm_mask () {0xd8;}' unless defined(&AOFF_mm_cpu_vm_mask);
	    eval 'sub ASIZ_mm_cpu_vm_mask () {0x8;}' unless defined(&ASIZ_mm_cpu_vm_mask);
	    eval 'sub AOFF_mm_swap_address () {0xe0;}' unless defined(&AOFF_mm_swap_address);
	    eval 'sub ASIZ_mm_swap_address () {0x8;}' unless defined(&ASIZ_mm_swap_address);
	    eval 'sub AOFF_mm_context () {0xf0;}' unless defined(&AOFF_mm_context);
	    eval 'sub ASIZ_mm_context () {0x8;}' unless defined(&ASIZ_mm_context);
	    eval 'sub ASIZ_mm () {0xf8;}' unless defined(&ASIZ_mm);
	    eval 'sub AOFF_thread_ksp () {0x;}' unless defined(&AOFF_thread_ksp);
	    eval 'sub ASIZ_thread_ksp () {0x8;}' unless defined(&ASIZ_thread_ksp);
	    eval 'sub AOFF_thread_wstate () {0x8;}' unless defined(&AOFF_thread_wstate);
	    eval 'sub ASIZ_thread_wstate () {0x1;}' unless defined(&ASIZ_thread_wstate);
	    eval 'sub AOFF_thread_cwp () {0x9;}' unless defined(&AOFF_thread_cwp);
	    eval 'sub ASIZ_thread_cwp () {0x1;}' unless defined(&ASIZ_thread_cwp);
	    eval 'sub AOFF_thread_flags () {0xa;}' unless defined(&AOFF_thread_flags);
	    eval 'sub ASIZ_thread_flags () {0x1;}' unless defined(&ASIZ_thread_flags);
	    eval 'sub AOFF_thread_current_ds () {0xb;}' unless defined(&AOFF_thread_current_ds);
	    eval 'sub ASIZ_thread_current_ds () {0x1;}' unless defined(&ASIZ_thread_current_ds);
	    eval 'sub AOFF_thread_w_saved () {0xc;}' unless defined(&AOFF_thread_w_saved);
	    eval 'sub ASIZ_thread_w_saved () {0x1;}' unless defined(&ASIZ_thread_w_saved);
	    eval 'sub AOFF_thread_fpdepth () {0xd;}' unless defined(&AOFF_thread_fpdepth);
	    eval 'sub ASIZ_thread_fpdepth () {0x1;}' unless defined(&ASIZ_thread_fpdepth);
	    eval 'sub AOFF_thread_fault_code () {0xe;}' unless defined(&AOFF_thread_fault_code);
	    eval 'sub ASIZ_thread_fault_code () {0x1;}' unless defined(&ASIZ_thread_fault_code);
	    eval 'sub AOFF_thread_use_blkcommit () {0xf;}' unless defined(&AOFF_thread_use_blkcommit);
	    eval 'sub ASIZ_thread_use_blkcommit () {0x1;}' unless defined(&ASIZ_thread_use_blkcommit);
	    eval 'sub AOFF_thread_fault_address () {0x10;}' unless defined(&AOFF_thread_fault_address);
	    eval 'sub ASIZ_thread_fault_address () {0x8;}' unless defined(&ASIZ_thread_fault_address);
	    eval 'sub AOFF_thread_fpsaved () {0x18;}' unless defined(&AOFF_thread_fpsaved);
	    eval 'sub ASIZ_thread_fpsaved () {0x7;}' unless defined(&ASIZ_thread_fpsaved);
	    eval 'sub AOFF_thread___pad2 () {0x1f;}' unless defined(&AOFF_thread___pad2);
	    eval 'sub ASIZ_thread___pad2 () {0x1;}' unless defined(&ASIZ_thread___pad2);
	    eval 'sub AOFF_thread_kregs () {0x20;}' unless defined(&AOFF_thread_kregs);
	    eval 'sub ASIZ_thread_kregs () {0x8;}' unless defined(&ASIZ_thread_kregs);
	    eval 'sub AOFF_thread_utraps () {0x28;}' unless defined(&AOFF_thread_utraps);
	    eval 'sub ASIZ_thread_utraps () {0x8;}' unless defined(&ASIZ_thread_utraps);
	    eval 'sub AOFF_thread_gsr () {0x30;}' unless defined(&AOFF_thread_gsr);
	    eval 'sub ASIZ_thread_gsr () {0x38;}' unless defined(&ASIZ_thread_gsr);
	    eval 'sub AOFF_thread_xfsr () {0x68;}' unless defined(&AOFF_thread_xfsr);
	    eval 'sub ASIZ_thread_xfsr () {0x38;}' unless defined(&ASIZ_thread_xfsr);
	    eval 'sub AOFF_thread_reg_window () {0xa0;}' unless defined(&AOFF_thread_reg_window);
	    eval 'sub ASIZ_thread_reg_window () {0x380;}' unless defined(&ASIZ_thread_reg_window);
	    eval 'sub AOFF_thread_rwbuf_stkptrs () {0x420;}' unless defined(&AOFF_thread_rwbuf_stkptrs);
	    eval 'sub ASIZ_thread_rwbuf_stkptrs () {0x38;}' unless defined(&ASIZ_thread_rwbuf_stkptrs);
	    eval 'sub AOFF_thread_user_cntd0 () {0x458;}' unless defined(&AOFF_thread_user_cntd0);
	    eval 'sub ASIZ_thread_user_cntd0 () {0x8;}' unless defined(&ASIZ_thread_user_cntd0);
	    eval 'sub AOFF_thread_user_cntd1 () {0x460;}' unless defined(&AOFF_thread_user_cntd1);
	    eval 'sub ASIZ_thread_user_cntd1 () {0x8;}' unless defined(&ASIZ_thread_user_cntd1);
	    eval 'sub AOFF_thread_kernel_cntd0 () {0x468;}' unless defined(&AOFF_thread_kernel_cntd0);
	    eval 'sub ASIZ_thread_kernel_cntd0 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd0);
	    eval 'sub AOFF_thread_kernel_cntd1 () {0x470;}' unless defined(&AOFF_thread_kernel_cntd1);
	    eval 'sub ASIZ_thread_kernel_cntd1 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd1);
	    eval 'sub AOFF_thread_pcr_reg () {0x478;}' unless defined(&AOFF_thread_pcr_reg);
	    eval 'sub ASIZ_thread_pcr_reg () {0x8;}' unless defined(&ASIZ_thread_pcr_reg);
	    eval 'sub ASIZ_thread () {0x480;}' unless defined(&ASIZ_thread);
	} else {
	    eval 'sub AOFF_task_state () {0x;}' unless defined(&AOFF_task_state);
	    eval 'sub ASIZ_task_state () {0x8;}' unless defined(&ASIZ_task_state);
	    eval 'sub AOFF_task_flags () {0x8;}' unless defined(&AOFF_task_flags);
	    eval 'sub ASIZ_task_flags () {0x8;}' unless defined(&ASIZ_task_flags);
	    eval 'sub AOFF_task_sigpending () {0x10;}' unless defined(&AOFF_task_sigpending);
	    eval 'sub ASIZ_task_sigpending () {0x4;}' unless defined(&ASIZ_task_sigpending);
	    eval 'sub AOFF_task_addr_limit () {0x14;}' unless defined(&AOFF_task_addr_limit);
	    eval 'sub ASIZ_task_addr_limit () {0x1;}' unless defined(&ASIZ_task_addr_limit);
	    eval 'sub AOFF_task_exec_domain () {0x18;}' unless defined(&AOFF_task_exec_domain);
	    eval 'sub ASIZ_task_exec_domain () {0x8;}' unless defined(&ASIZ_task_exec_domain);
	    eval 'sub AOFF_task_need_resched () {0x20;}' unless defined(&AOFF_task_need_resched);
	    eval 'sub ASIZ_task_need_resched () {0x8;}' unless defined(&ASIZ_task_need_resched);
	    eval 'sub AOFF_task_ptrace () {0x28;}' unless defined(&AOFF_task_ptrace);
	    eval 'sub ASIZ_task_ptrace () {0x8;}' unless defined(&ASIZ_task_ptrace);
	    eval 'sub AOFF_task_lock_depth () {0x30;}' unless defined(&AOFF_task_lock_depth);
	    eval 'sub ASIZ_task_lock_depth () {0x4;}' unless defined(&ASIZ_task_lock_depth);
	    eval 'sub AOFF_task_counter () {0x38;}' unless defined(&AOFF_task_counter);
	    eval 'sub ASIZ_task_counter () {0x8;}' unless defined(&ASIZ_task_counter);
	    eval 'sub AOFF_task_nice () {0x40;}' unless defined(&AOFF_task_nice);
	    eval 'sub ASIZ_task_nice () {0x8;}' unless defined(&ASIZ_task_nice);
	    eval 'sub AOFF_task_policy () {0x48;}' unless defined(&AOFF_task_policy);
	    eval 'sub ASIZ_task_policy () {0x8;}' unless defined(&ASIZ_task_policy);
	    eval 'sub AOFF_task_mm () {0x50;}' unless defined(&AOFF_task_mm);
	    eval 'sub ASIZ_task_mm () {0x8;}' unless defined(&ASIZ_task_mm);
	    eval 'sub AOFF_task_processor () {0x58;}' unless defined(&AOFF_task_processor);
	    eval 'sub ASIZ_task_processor () {0x4;}' unless defined(&ASIZ_task_processor);
	    eval 'sub AOFF_task_cpus_runnable () {0x60;}' unless defined(&AOFF_task_cpus_runnable);
	    eval 'sub ASIZ_task_cpus_runnable () {0x8;}' unless defined(&ASIZ_task_cpus_runnable);
	    eval 'sub AOFF_task_cpus_allowed () {0x68;}' unless defined(&AOFF_task_cpus_allowed);
	    eval 'sub ASIZ_task_cpus_allowed () {0x8;}' unless defined(&ASIZ_task_cpus_allowed);
	    eval 'sub AOFF_task_run_list () {0x70;}' unless defined(&AOFF_task_run_list);
	    eval 'sub ASIZ_task_run_list () {0x10;}' unless defined(&ASIZ_task_run_list);
	    eval 'sub AOFF_task_sleep_time () {0x80;}' unless defined(&AOFF_task_sleep_time);
	    eval 'sub ASIZ_task_sleep_time () {0x8;}' unless defined(&ASIZ_task_sleep_time);
	    eval 'sub AOFF_task_next_task () {0x88;}' unless defined(&AOFF_task_next_task);
	    eval 'sub ASIZ_task_next_task () {0x8;}' unless defined(&ASIZ_task_next_task);
	    eval 'sub AOFF_task_prev_task () {0x90;}' unless defined(&AOFF_task_prev_task);
	    eval 'sub ASIZ_task_prev_task () {0x8;}' unless defined(&ASIZ_task_prev_task);
	    eval 'sub AOFF_task_active_mm () {0x98;}' unless defined(&AOFF_task_active_mm);
	    eval 'sub ASIZ_task_active_mm () {0x8;}' unless defined(&ASIZ_task_active_mm);
	    eval 'sub AOFF_task_local_pages () {0xa0;}' unless defined(&AOFF_task_local_pages);
	    eval 'sub ASIZ_task_local_pages () {0x10;}' unless defined(&ASIZ_task_local_pages);
	    eval 'sub AOFF_task_allocation_order () {0xb0;}' unless defined(&AOFF_task_allocation_order);
	    eval 'sub ASIZ_task_allocation_order () {0x4;}' unless defined(&ASIZ_task_allocation_order);
	    eval 'sub AOFF_task_nr_local_pages () {0xb4;}' unless defined(&AOFF_task_nr_local_pages);
	    eval 'sub ASIZ_task_nr_local_pages () {0x4;}' unless defined(&ASIZ_task_nr_local_pages);
	    eval 'sub AOFF_task_binfmt () {0xb8;}' unless defined(&AOFF_task_binfmt);
	    eval 'sub ASIZ_task_binfmt () {0x8;}' unless defined(&ASIZ_task_binfmt);
	    eval 'sub AOFF_task_exit_code () {0xc0;}' unless defined(&AOFF_task_exit_code);
	    eval 'sub ASIZ_task_exit_code () {0x4;}' unless defined(&ASIZ_task_exit_code);
	    eval 'sub AOFF_task_exit_signal () {0xc4;}' unless defined(&AOFF_task_exit_signal);
	    eval 'sub ASIZ_task_exit_signal () {0x4;}' unless defined(&ASIZ_task_exit_signal);
	    eval 'sub AOFF_task_pdeath_signal () {0xc8;}' unless defined(&AOFF_task_pdeath_signal);
	    eval 'sub ASIZ_task_pdeath_signal () {0x4;}' unless defined(&ASIZ_task_pdeath_signal);
	    eval 'sub AOFF_task_personality () {0xd0;}' unless defined(&AOFF_task_personality);
	    eval 'sub ASIZ_task_personality () {0x8;}' unless defined(&ASIZ_task_personality);
	    eval 'sub AOFF_task_pid () {0xdc;}' unless defined(&AOFF_task_pid);
	    eval 'sub ASIZ_task_pid () {0x4;}' unless defined(&ASIZ_task_pid);
	    eval 'sub AOFF_task_pgrp () {0xe0;}' unless defined(&AOFF_task_pgrp);
	    eval 'sub ASIZ_task_pgrp () {0x4;}' unless defined(&ASIZ_task_pgrp);
	    eval 'sub AOFF_task_tty_old_pgrp () {0xe4;}' unless defined(&AOFF_task_tty_old_pgrp);
	    eval 'sub ASIZ_task_tty_old_pgrp () {0x4;}' unless defined(&ASIZ_task_tty_old_pgrp);
	    eval 'sub AOFF_task_session () {0xe8;}' unless defined(&AOFF_task_session);
	    eval 'sub ASIZ_task_session () {0x4;}' unless defined(&ASIZ_task_session);
	    eval 'sub AOFF_task_tgid () {0xec;}' unless defined(&AOFF_task_tgid);
	    eval 'sub ASIZ_task_tgid () {0x4;}' unless defined(&ASIZ_task_tgid);
	    eval 'sub AOFF_task_leader () {0xf0;}' unless defined(&AOFF_task_leader);
	    eval 'sub ASIZ_task_leader () {0x4;}' unless defined(&ASIZ_task_leader);
	    eval 'sub AOFF_task_p_opptr () {0xf8;}' unless defined(&AOFF_task_p_opptr);
	    eval 'sub ASIZ_task_p_opptr () {0x8;}' unless defined(&ASIZ_task_p_opptr);
	    eval 'sub AOFF_task_p_pptr () {0x100;}' unless defined(&AOFF_task_p_pptr);
	    eval 'sub ASIZ_task_p_pptr () {0x8;}' unless defined(&ASIZ_task_p_pptr);
	    eval 'sub AOFF_task_p_cptr () {0x108;}' unless defined(&AOFF_task_p_cptr);
	    eval 'sub ASIZ_task_p_cptr () {0x8;}' unless defined(&ASIZ_task_p_cptr);
	    eval 'sub AOFF_task_p_ysptr () {0x110;}' unless defined(&AOFF_task_p_ysptr);
	    eval 'sub ASIZ_task_p_ysptr () {0x8;}' unless defined(&ASIZ_task_p_ysptr);
	    eval 'sub AOFF_task_p_osptr () {0x118;}' unless defined(&AOFF_task_p_osptr);
	    eval 'sub ASIZ_task_p_osptr () {0x8;}' unless defined(&ASIZ_task_p_osptr);
	    eval 'sub AOFF_task_thread_group () {0x120;}' unless defined(&AOFF_task_thread_group);
	    eval 'sub ASIZ_task_thread_group () {0x10;}' unless defined(&ASIZ_task_thread_group);
	    eval 'sub AOFF_task_pidhash_next () {0x130;}' unless defined(&AOFF_task_pidhash_next);
	    eval 'sub ASIZ_task_pidhash_next () {0x8;}' unless defined(&ASIZ_task_pidhash_next);
	    eval 'sub AOFF_task_pidhash_pprev () {0x138;}' unless defined(&AOFF_task_pidhash_pprev);
	    eval 'sub ASIZ_task_pidhash_pprev () {0x8;}' unless defined(&ASIZ_task_pidhash_pprev);
	    eval 'sub AOFF_task_wait_chldexit () {0x140;}' unless defined(&AOFF_task_wait_chldexit);
	    eval 'sub ASIZ_task_wait_chldexit () {0x18;}' unless defined(&ASIZ_task_wait_chldexit);
	    eval 'sub AOFF_task_vfork_done () {0x158;}' unless defined(&AOFF_task_vfork_done);
	    eval 'sub ASIZ_task_vfork_done () {0x8;}' unless defined(&ASIZ_task_vfork_done);
	    eval 'sub AOFF_task_rt_priority () {0x160;}' unless defined(&AOFF_task_rt_priority);
	    eval 'sub ASIZ_task_rt_priority () {0x8;}' unless defined(&ASIZ_task_rt_priority);
	    eval 'sub AOFF_task_it_real_value () {0x168;}' unless defined(&AOFF_task_it_real_value);
	    eval 'sub ASIZ_task_it_real_value () {0x8;}' unless defined(&ASIZ_task_it_real_value);
	    eval 'sub AOFF_task_it_prof_value () {0x170;}' unless defined(&AOFF_task_it_prof_value);
	    eval 'sub ASIZ_task_it_prof_value () {0x8;}' unless defined(&ASIZ_task_it_prof_value);
	    eval 'sub AOFF_task_it_virt_value () {0x178;}' unless defined(&AOFF_task_it_virt_value);
	    eval 'sub ASIZ_task_it_virt_value () {0x8;}' unless defined(&ASIZ_task_it_virt_value);
	    eval 'sub AOFF_task_it_real_incr () {0x180;}' unless defined(&AOFF_task_it_real_incr);
	    eval 'sub ASIZ_task_it_real_incr () {0x8;}' unless defined(&ASIZ_task_it_real_incr);
	    eval 'sub AOFF_task_it_prof_incr () {0x188;}' unless defined(&AOFF_task_it_prof_incr);
	    eval 'sub ASIZ_task_it_prof_incr () {0x8;}' unless defined(&ASIZ_task_it_prof_incr);
	    eval 'sub AOFF_task_it_virt_incr () {0x190;}' unless defined(&AOFF_task_it_virt_incr);
	    eval 'sub ASIZ_task_it_virt_incr () {0x8;}' unless defined(&ASIZ_task_it_virt_incr);
	    eval 'sub AOFF_task_real_timer () {0x198;}' unless defined(&AOFF_task_real_timer);
	    eval 'sub ASIZ_task_real_timer () {0x28;}' unless defined(&ASIZ_task_real_timer);
	    eval 'sub AOFF_task_times () {0x1c0;}' unless defined(&AOFF_task_times);
	    eval 'sub ASIZ_task_times () {0x20;}' unless defined(&ASIZ_task_times);
	    eval 'sub AOFF_task_start_time () {0x1e0;}' unless defined(&AOFF_task_start_time);
	    eval 'sub ASIZ_task_start_time () {0x8;}' unless defined(&ASIZ_task_start_time);
	    eval 'sub AOFF_task_per_cpu_utime () {0x1e8;}' unless defined(&AOFF_task_per_cpu_utime);
	    eval 'sub ASIZ_task_per_cpu_utime () {0x100;}' unless defined(&ASIZ_task_per_cpu_utime);
	    eval 'sub AOFF_task_min_flt () {0x3e8;}' unless defined(&AOFF_task_min_flt);
	    eval 'sub ASIZ_task_min_flt () {0x8;}' unless defined(&ASIZ_task_min_flt);
	    eval 'sub AOFF_task_maj_flt () {0x3f0;}' unless defined(&AOFF_task_maj_flt);
	    eval 'sub ASIZ_task_maj_flt () {0x8;}' unless defined(&ASIZ_task_maj_flt);
	    eval 'sub AOFF_task_nswap () {0x3f8;}' unless defined(&AOFF_task_nswap);
	    eval 'sub ASIZ_task_nswap () {0x8;}' unless defined(&ASIZ_task_nswap);
	    eval 'sub AOFF_task_cmin_flt () {0x400;}' unless defined(&AOFF_task_cmin_flt);
	    eval 'sub ASIZ_task_cmin_flt () {0x8;}' unless defined(&ASIZ_task_cmin_flt);
	    eval 'sub AOFF_task_cmaj_flt () {0x408;}' unless defined(&AOFF_task_cmaj_flt);
	    eval 'sub ASIZ_task_cmaj_flt () {0x8;}' unless defined(&ASIZ_task_cmaj_flt);
	    eval 'sub AOFF_task_cnswap () {0x410;}' unless defined(&AOFF_task_cnswap);
	    eval 'sub ASIZ_task_cnswap () {0x8;}' unless defined(&ASIZ_task_cnswap);
	    eval 'sub AOFF_task_uid () {0x41c;}' unless defined(&AOFF_task_uid);
	    eval 'sub ASIZ_task_uid () {0x4;}' unless defined(&ASIZ_task_uid);
	    eval 'sub AOFF_task_euid () {0x420;}' unless defined(&AOFF_task_euid);
	    eval 'sub ASIZ_task_euid () {0x4;}' unless defined(&ASIZ_task_euid);
	    eval 'sub AOFF_task_suid () {0x424;}' unless defined(&AOFF_task_suid);
	    eval 'sub ASIZ_task_suid () {0x4;}' unless defined(&ASIZ_task_suid);
	    eval 'sub AOFF_task_fsuid () {0x428;}' unless defined(&AOFF_task_fsuid);
	    eval 'sub ASIZ_task_fsuid () {0x4;}' unless defined(&ASIZ_task_fsuid);
	    eval 'sub AOFF_task_gid () {0x42c;}' unless defined(&AOFF_task_gid);
	    eval 'sub ASIZ_task_gid () {0x4;}' unless defined(&ASIZ_task_gid);
	    eval 'sub AOFF_task_egid () {0x430;}' unless defined(&AOFF_task_egid);
	    eval 'sub ASIZ_task_egid () {0x4;}' unless defined(&ASIZ_task_egid);
	    eval 'sub AOFF_task_sgid () {0x434;}' unless defined(&AOFF_task_sgid);
	    eval 'sub ASIZ_task_sgid () {0x4;}' unless defined(&ASIZ_task_sgid);
	    eval 'sub AOFF_task_fsgid () {0x438;}' unless defined(&AOFF_task_fsgid);
	    eval 'sub ASIZ_task_fsgid () {0x4;}' unless defined(&ASIZ_task_fsgid);
	    eval 'sub AOFF_task_ngroups () {0x43c;}' unless defined(&AOFF_task_ngroups);
	    eval 'sub ASIZ_task_ngroups () {0x4;}' unless defined(&ASIZ_task_ngroups);
	    eval 'sub AOFF_task_groups () {0x440;}' unless defined(&AOFF_task_groups);
	    eval 'sub ASIZ_task_groups () {0x80;}' unless defined(&ASIZ_task_groups);
	    eval 'sub AOFF_task_cap_effective () {0x4c0;}' unless defined(&AOFF_task_cap_effective);
	    eval 'sub ASIZ_task_cap_effective () {0x4;}' unless defined(&ASIZ_task_cap_effective);
	    eval 'sub AOFF_task_cap_inheritable () {0x4c4;}' unless defined(&AOFF_task_cap_inheritable);
	    eval 'sub ASIZ_task_cap_inheritable () {0x4;}' unless defined(&ASIZ_task_cap_inheritable);
	    eval 'sub AOFF_task_cap_permitted () {0x4c8;}' unless defined(&AOFF_task_cap_permitted);
	    eval 'sub ASIZ_task_cap_permitted () {0x4;}' unless defined(&ASIZ_task_cap_permitted);
	    eval 'sub AOFF_task_user () {0x4d0;}' unless defined(&AOFF_task_user);
	    eval 'sub ASIZ_task_user () {0x8;}' unless defined(&ASIZ_task_user);
	    eval 'sub AOFF_task_rlim () {0x4d8;}' unless defined(&AOFF_task_rlim);
	    eval 'sub ASIZ_task_rlim () {0xb0;}' unless defined(&ASIZ_task_rlim);
	    eval 'sub AOFF_task_used_math () {0x588;}' unless defined(&AOFF_task_used_math);
	    eval 'sub ASIZ_task_used_math () {0x2;}' unless defined(&ASIZ_task_used_math);
	    eval 'sub AOFF_task_comm () {0x58a;}' unless defined(&AOFF_task_comm);
	    eval 'sub ASIZ_task_comm () {0x10;}' unless defined(&ASIZ_task_comm);
	    eval 'sub AOFF_task_link_count () {0x59c;}' unless defined(&AOFF_task_link_count);
	    eval 'sub ASIZ_task_link_count () {0x4;}' unless defined(&ASIZ_task_link_count);
	    eval 'sub AOFF_task_total_link_count () {0x5a0;}' unless defined(&AOFF_task_total_link_count);
	    eval 'sub ASIZ_task_total_link_count () {0x4;}' unless defined(&ASIZ_task_total_link_count);
	    eval 'sub AOFF_task_tty () {0x5a8;}' unless defined(&AOFF_task_tty);
	    eval 'sub ASIZ_task_tty () {0x8;}' unless defined(&ASIZ_task_tty);
	    eval 'sub AOFF_task_locks () {0x5b0;}' unless defined(&AOFF_task_locks);
	    eval 'sub ASIZ_task_locks () {0x4;}' unless defined(&ASIZ_task_locks);
	    eval 'sub AOFF_task_semundo () {0x5b8;}' unless defined(&AOFF_task_semundo);
	    eval 'sub ASIZ_task_semundo () {0x8;}' unless defined(&ASIZ_task_semundo);
	    eval 'sub AOFF_task_semsleeping () {0x5c0;}' unless defined(&AOFF_task_semsleeping);
	    eval 'sub ASIZ_task_semsleeping () {0x8;}' unless defined(&ASIZ_task_semsleeping);
	    eval 'sub AOFF_task_thread () {0x5d0;}' unless defined(&AOFF_task_thread);
	    eval 'sub ASIZ_task_thread () {0x480;}' unless defined(&ASIZ_task_thread);
	    eval 'sub AOFF_task_fs () {0xa50;}' unless defined(&AOFF_task_fs);
	    eval 'sub ASIZ_task_fs () {0x8;}' unless defined(&ASIZ_task_fs);
	    eval 'sub AOFF_task_files () {0xa58;}' unless defined(&AOFF_task_files);
	    eval 'sub ASIZ_task_files () {0x8;}' unless defined(&ASIZ_task_files);
	    eval 'sub AOFF_task_namespace () {0xa60;}' unless defined(&AOFF_task_namespace);
	    eval 'sub ASIZ_task_namespace () {0x8;}' unless defined(&ASIZ_task_namespace);
	    eval 'sub AOFF_task_sigmask_lock () {0xa68;}' unless defined(&AOFF_task_sigmask_lock);
	    eval 'sub ASIZ_task_sigmask_lock () {0x1;}' unless defined(&ASIZ_task_sigmask_lock);
	    eval 'sub AOFF_task_sig () {0xa70;}' unless defined(&AOFF_task_sig);
	    eval 'sub ASIZ_task_sig () {0x8;}' unless defined(&ASIZ_task_sig);
	    eval 'sub AOFF_task_blocked () {0xa78;}' unless defined(&AOFF_task_blocked);
	    eval 'sub ASIZ_task_blocked () {0x8;}' unless defined(&ASIZ_task_blocked);
	    eval 'sub AOFF_task_pending () {0xa80;}' unless defined(&AOFF_task_pending);
	    eval 'sub ASIZ_task_pending () {0x18;}' unless defined(&ASIZ_task_pending);
	    eval 'sub AOFF_task_sas_ss_sp () {0xa98;}' unless defined(&AOFF_task_sas_ss_sp);
	    eval 'sub ASIZ_task_sas_ss_sp () {0x8;}' unless defined(&ASIZ_task_sas_ss_sp);
	    eval 'sub AOFF_task_sas_ss_size () {0xaa0;}' unless defined(&AOFF_task_sas_ss_size);
	    eval 'sub ASIZ_task_sas_ss_size () {0x8;}' unless defined(&ASIZ_task_sas_ss_size);
	    eval 'sub AOFF_task_notifier () {0xaa8;}' unless defined(&AOFF_task_notifier);
	    eval 'sub ASIZ_task_notifier () {0x8;}' unless defined(&ASIZ_task_notifier);
	    eval 'sub AOFF_task_notifier_data () {0xab0;}' unless defined(&AOFF_task_notifier_data);
	    eval 'sub ASIZ_task_notifier_data () {0x8;}' unless defined(&ASIZ_task_notifier_data);
	    eval 'sub AOFF_task_notifier_mask () {0xab8;}' unless defined(&AOFF_task_notifier_mask);
	    eval 'sub ASIZ_task_notifier_mask () {0x8;}' unless defined(&ASIZ_task_notifier_mask);
	    eval 'sub AOFF_task_parent_exec_id () {0xac0;}' unless defined(&AOFF_task_parent_exec_id);
	    eval 'sub ASIZ_task_parent_exec_id () {0x4;}' unless defined(&ASIZ_task_parent_exec_id);
	    eval 'sub AOFF_task_self_exec_id () {0xac4;}' unless defined(&AOFF_task_self_exec_id);
	    eval 'sub ASIZ_task_self_exec_id () {0x4;}' unless defined(&ASIZ_task_self_exec_id);
	    eval 'sub AOFF_task_alloc_lock () {0xac8;}' unless defined(&AOFF_task_alloc_lock);
	    eval 'sub ASIZ_task_alloc_lock () {0x1;}' unless defined(&ASIZ_task_alloc_lock);
	    eval 'sub AOFF_task_journal_info () {0xad0;}' unless defined(&AOFF_task_journal_info);
	    eval 'sub ASIZ_task_journal_info () {0x8;}' unless defined(&ASIZ_task_journal_info);
	    eval 'sub ASIZ_task () {0xae0;}' unless defined(&ASIZ_task);
	    eval 'sub AOFF_mm_mmap () {0x;}' unless defined(&AOFF_mm_mmap);
	    eval 'sub ASIZ_mm_mmap () {0x8;}' unless defined(&ASIZ_mm_mmap);
	    eval 'sub AOFF_mm_mm_rb () {0x8;}' unless defined(&AOFF_mm_mm_rb);
	    eval 'sub ASIZ_mm_mm_rb () {0x8;}' unless defined(&ASIZ_mm_mm_rb);
	    eval 'sub AOFF_mm_mmap_cache () {0x10;}' unless defined(&AOFF_mm_mmap_cache);
	    eval 'sub ASIZ_mm_mmap_cache () {0x8;}' unless defined(&ASIZ_mm_mmap_cache);
	    eval 'sub AOFF_mm_pgd () {0x18;}' unless defined(&AOFF_mm_pgd);
	    eval 'sub ASIZ_mm_pgd () {0x8;}' unless defined(&ASIZ_mm_pgd);
	    eval 'sub AOFF_mm_mm_users () {0x20;}' unless defined(&AOFF_mm_mm_users);
	    eval 'sub ASIZ_mm_mm_users () {0x4;}' unless defined(&ASIZ_mm_mm_users);
	    eval 'sub AOFF_mm_mm_count () {0x24;}' unless defined(&AOFF_mm_mm_count);
	    eval 'sub ASIZ_mm_mm_count () {0x4;}' unless defined(&ASIZ_mm_mm_count);
	    eval 'sub AOFF_mm_map_count () {0x28;}' unless defined(&AOFF_mm_map_count);
	    eval 'sub ASIZ_mm_map_count () {0x4;}' unless defined(&ASIZ_mm_map_count);
	    eval 'sub AOFF_mm_mmap_sem () {0x30;}' unless defined(&AOFF_mm_mmap_sem);
	    eval 'sub ASIZ_mm_mmap_sem () {0x18;}' unless defined(&ASIZ_mm_mmap_sem);
	    eval 'sub AOFF_mm_page_table_lock () {0x48;}' unless defined(&AOFF_mm_page_table_lock);
	    eval 'sub ASIZ_mm_page_table_lock () {0x1;}' unless defined(&ASIZ_mm_page_table_lock);
	    eval 'sub AOFF_mm_mmlist () {0x50;}' unless defined(&AOFF_mm_mmlist);
	    eval 'sub ASIZ_mm_mmlist () {0x10;}' unless defined(&ASIZ_mm_mmlist);
	    eval 'sub AOFF_mm_start_code () {0x60;}' unless defined(&AOFF_mm_start_code);
	    eval 'sub ASIZ_mm_start_code () {0x8;}' unless defined(&ASIZ_mm_start_code);
	    eval 'sub AOFF_mm_end_code () {0x68;}' unless defined(&AOFF_mm_end_code);
	    eval 'sub ASIZ_mm_end_code () {0x8;}' unless defined(&ASIZ_mm_end_code);
	    eval 'sub AOFF_mm_start_data () {0x70;}' unless defined(&AOFF_mm_start_data);
	    eval 'sub ASIZ_mm_start_data () {0x8;}' unless defined(&ASIZ_mm_start_data);
	    eval 'sub AOFF_mm_end_data () {0x78;}' unless defined(&AOFF_mm_end_data);
	    eval 'sub ASIZ_mm_end_data () {0x8;}' unless defined(&ASIZ_mm_end_data);
	    eval 'sub AOFF_mm_start_brk () {0x80;}' unless defined(&AOFF_mm_start_brk);
	    eval 'sub ASIZ_mm_start_brk () {0x8;}' unless defined(&ASIZ_mm_start_brk);
	    eval 'sub AOFF_mm_brk () {0x88;}' unless defined(&AOFF_mm_brk);
	    eval 'sub ASIZ_mm_brk () {0x8;}' unless defined(&ASIZ_mm_brk);
	    eval 'sub AOFF_mm_start_stack () {0x90;}' unless defined(&AOFF_mm_start_stack);
	    eval 'sub ASIZ_mm_start_stack () {0x8;}' unless defined(&ASIZ_mm_start_stack);
	    eval 'sub AOFF_mm_arg_start () {0x98;}' unless defined(&AOFF_mm_arg_start);
	    eval 'sub ASIZ_mm_arg_start () {0x8;}' unless defined(&ASIZ_mm_arg_start);
	    eval 'sub AOFF_mm_arg_end () {0xa0;}' unless defined(&AOFF_mm_arg_end);
	    eval 'sub ASIZ_mm_arg_end () {0x8;}' unless defined(&ASIZ_mm_arg_end);
	    eval 'sub AOFF_mm_env_start () {0xa8;}' unless defined(&AOFF_mm_env_start);
	    eval 'sub ASIZ_mm_env_start () {0x8;}' unless defined(&ASIZ_mm_env_start);
	    eval 'sub AOFF_mm_env_end () {0xb0;}' unless defined(&AOFF_mm_env_end);
	    eval 'sub ASIZ_mm_env_end () {0x8;}' unless defined(&ASIZ_mm_env_end);
	    eval 'sub AOFF_mm_rss () {0xb8;}' unless defined(&AOFF_mm_rss);
	    eval 'sub ASIZ_mm_rss () {0x8;}' unless defined(&ASIZ_mm_rss);
	    eval 'sub AOFF_mm_total_vm () {0xc0;}' unless defined(&AOFF_mm_total_vm);
	    eval 'sub ASIZ_mm_total_vm () {0x8;}' unless defined(&ASIZ_mm_total_vm);
	    eval 'sub AOFF_mm_locked_vm () {0xc8;}' unless defined(&AOFF_mm_locked_vm);
	    eval 'sub ASIZ_mm_locked_vm () {0x8;}' unless defined(&ASIZ_mm_locked_vm);
	    eval 'sub AOFF_mm_def_flags () {0xd0;}' unless defined(&AOFF_mm_def_flags);
	    eval 'sub ASIZ_mm_def_flags () {0x8;}' unless defined(&ASIZ_mm_def_flags);
	    eval 'sub AOFF_mm_cpu_vm_mask () {0xd8;}' unless defined(&AOFF_mm_cpu_vm_mask);
	    eval 'sub ASIZ_mm_cpu_vm_mask () {0x8;}' unless defined(&ASIZ_mm_cpu_vm_mask);
	    eval 'sub AOFF_mm_swap_address () {0xe0;}' unless defined(&AOFF_mm_swap_address);
	    eval 'sub ASIZ_mm_swap_address () {0x8;}' unless defined(&ASIZ_mm_swap_address);
	    eval 'sub AOFF_mm_context () {0xf0;}' unless defined(&AOFF_mm_context);
	    eval 'sub ASIZ_mm_context () {0x8;}' unless defined(&ASIZ_mm_context);
	    eval 'sub ASIZ_mm () {0xf8;}' unless defined(&ASIZ_mm);
	    eval 'sub AOFF_thread_ksp () {0x;}' unless defined(&AOFF_thread_ksp);
	    eval 'sub ASIZ_thread_ksp () {0x8;}' unless defined(&ASIZ_thread_ksp);
	    eval 'sub AOFF_thread_wstate () {0x8;}' unless defined(&AOFF_thread_wstate);
	    eval 'sub ASIZ_thread_wstate () {0x1;}' unless defined(&ASIZ_thread_wstate);
	    eval 'sub AOFF_thread_cwp () {0x9;}' unless defined(&AOFF_thread_cwp);
	    eval 'sub ASIZ_thread_cwp () {0x1;}' unless defined(&ASIZ_thread_cwp);
	    eval 'sub AOFF_thread_flags () {0xa;}' unless defined(&AOFF_thread_flags);
	    eval 'sub ASIZ_thread_flags () {0x1;}' unless defined(&ASIZ_thread_flags);
	    eval 'sub AOFF_thread_current_ds () {0xb;}' unless defined(&AOFF_thread_current_ds);
	    eval 'sub ASIZ_thread_current_ds () {0x1;}' unless defined(&ASIZ_thread_current_ds);
	    eval 'sub AOFF_thread_w_saved () {0xc;}' unless defined(&AOFF_thread_w_saved);
	    eval 'sub ASIZ_thread_w_saved () {0x1;}' unless defined(&ASIZ_thread_w_saved);
	    eval 'sub AOFF_thread_fpdepth () {0xd;}' unless defined(&AOFF_thread_fpdepth);
	    eval 'sub ASIZ_thread_fpdepth () {0x1;}' unless defined(&ASIZ_thread_fpdepth);
	    eval 'sub AOFF_thread_fault_code () {0xe;}' unless defined(&AOFF_thread_fault_code);
	    eval 'sub ASIZ_thread_fault_code () {0x1;}' unless defined(&ASIZ_thread_fault_code);
	    eval 'sub AOFF_thread_use_blkcommit () {0xf;}' unless defined(&AOFF_thread_use_blkcommit);
	    eval 'sub ASIZ_thread_use_blkcommit () {0x1;}' unless defined(&ASIZ_thread_use_blkcommit);
	    eval 'sub AOFF_thread_fault_address () {0x10;}' unless defined(&AOFF_thread_fault_address);
	    eval 'sub ASIZ_thread_fault_address () {0x8;}' unless defined(&ASIZ_thread_fault_address);
	    eval 'sub AOFF_thread_fpsaved () {0x18;}' unless defined(&AOFF_thread_fpsaved);
	    eval 'sub ASIZ_thread_fpsaved () {0x7;}' unless defined(&ASIZ_thread_fpsaved);
	    eval 'sub AOFF_thread___pad2 () {0x1f;}' unless defined(&AOFF_thread___pad2);
	    eval 'sub ASIZ_thread___pad2 () {0x1;}' unless defined(&ASIZ_thread___pad2);
	    eval 'sub AOFF_thread_kregs () {0x20;}' unless defined(&AOFF_thread_kregs);
	    eval 'sub ASIZ_thread_kregs () {0x8;}' unless defined(&ASIZ_thread_kregs);
	    eval 'sub AOFF_thread_utraps () {0x28;}' unless defined(&AOFF_thread_utraps);
	    eval 'sub ASIZ_thread_utraps () {0x8;}' unless defined(&ASIZ_thread_utraps);
	    eval 'sub AOFF_thread_gsr () {0x30;}' unless defined(&AOFF_thread_gsr);
	    eval 'sub ASIZ_thread_gsr () {0x38;}' unless defined(&ASIZ_thread_gsr);
	    eval 'sub AOFF_thread_xfsr () {0x68;}' unless defined(&AOFF_thread_xfsr);
	    eval 'sub ASIZ_thread_xfsr () {0x38;}' unless defined(&ASIZ_thread_xfsr);
	    eval 'sub AOFF_thread_reg_window () {0xa0;}' unless defined(&AOFF_thread_reg_window);
	    eval 'sub ASIZ_thread_reg_window () {0x380;}' unless defined(&ASIZ_thread_reg_window);
	    eval 'sub AOFF_thread_rwbuf_stkptrs () {0x420;}' unless defined(&AOFF_thread_rwbuf_stkptrs);
	    eval 'sub ASIZ_thread_rwbuf_stkptrs () {0x38;}' unless defined(&ASIZ_thread_rwbuf_stkptrs);
	    eval 'sub AOFF_thread_user_cntd0 () {0x458;}' unless defined(&AOFF_thread_user_cntd0);
	    eval 'sub ASIZ_thread_user_cntd0 () {0x8;}' unless defined(&ASIZ_thread_user_cntd0);
	    eval 'sub AOFF_thread_user_cntd1 () {0x460;}' unless defined(&AOFF_thread_user_cntd1);
	    eval 'sub ASIZ_thread_user_cntd1 () {0x8;}' unless defined(&ASIZ_thread_user_cntd1);
	    eval 'sub AOFF_thread_kernel_cntd0 () {0x468;}' unless defined(&AOFF_thread_kernel_cntd0);
	    eval 'sub ASIZ_thread_kernel_cntd0 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd0);
	    eval 'sub AOFF_thread_kernel_cntd1 () {0x470;}' unless defined(&AOFF_thread_kernel_cntd1);
	    eval 'sub ASIZ_thread_kernel_cntd1 () {0x8;}' unless defined(&ASIZ_thread_kernel_cntd1);
	    eval 'sub AOFF_thread_pcr_reg () {0x478;}' unless defined(&AOFF_thread_pcr_reg);
	    eval 'sub ASIZ_thread_pcr_reg () {0x8;}' unless defined(&ASIZ_thread_pcr_reg);
	    eval 'sub ASIZ_thread () {0x480;}' unless defined(&ASIZ_thread);
	}
    }
}
1;
