require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_IRQ_H)) {
    eval 'sub _SPARC64_IRQ_H () {1;}' unless defined(&_SPARC64_IRQ_H);
    require 'linux/config.ph';
    require 'linux/linkage.ph';
    require 'linux/kernel.ph';
    require 'asm/pil.ph';
    require 'asm/ptrace.ph';
    if(defined(&CONFIG_PCI)) {
    }
    eval 'sub IMAP_VALID () {0x80000000;}' unless defined(&IMAP_VALID);
    eval 'sub IMAP_TID_UPA () {0x7c000000;}' unless defined(&IMAP_TID_UPA);
    eval 'sub IMAP_AID_SAFARI () {0x7c000000;}' unless defined(&IMAP_AID_SAFARI);
    eval 'sub IMAP_NID_SAFARI () {0x3e00000;}' unless defined(&IMAP_NID_SAFARI);
    eval 'sub IMAP_IGN () {0x7c0;}' unless defined(&IMAP_IGN);
    eval 'sub IMAP_INO () {0x3f;}' unless defined(&IMAP_INO);
    eval 'sub IMAP_INR () {0x7ff;}' unless defined(&IMAP_INR);
    eval 'sub ICLR_IDLE () {0x;}' unless defined(&ICLR_IDLE);
    eval 'sub ICLR_TRANSMIT () {0x1;}' unless defined(&ICLR_TRANSMIT);
    eval 'sub ICLR_PENDING () {0x3;}' unless defined(&ICLR_PENDING);
    eval 'sub IBF_DMA_SYNC () {0x1;}' unless defined(&IBF_DMA_SYNC);
    eval 'sub IBF_PCI () {0x2;}' unless defined(&IBF_PCI);
    eval 'sub IBF_ACTIVE () {0x4;}' unless defined(&IBF_ACTIVE);
    eval 'sub IBF_MULTI () {0x8;}' unless defined(&IBF_MULTI);
    eval 'sub NUM_IVECS () {8192;}' unless defined(&NUM_IVECS);
    eval 'sub __irq_ino {
        local($irq) = @_;
	    eval q(((($irq)) -  $ivector_table[0]));
    }' unless defined(&__irq_ino);
    eval 'sub __irq_pil {
        local($irq) = @_;
	    eval q((($irq))-> &pil);
    }' unless defined(&__irq_pil);
    eval 'sub __bucket {
        local($irq) = @_;
	    eval q((($irq)));
    }' unless defined(&__bucket);
    eval 'sub __irq {
        local($bucket) = @_;
	    eval q((($bucket)));
    }' unless defined(&__irq);
    eval 'sub NR_IRQS () {16;}' unless defined(&NR_IRQS);
    eval 'sub disable_irq_nosync () { &disable_irq;}' unless defined(&disable_irq_nosync);
    if(defined(&CONFIG_SMP)) {
    }
}
1;
