require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_PCI_H)) {
    eval 'sub __SPARC64_PCI_H () {1;}' unless defined(&__SPARC64_PCI_H);
    if(defined(&__KERNEL__)) {
	require 'linux/fs.ph';
	require 'linux/mm.ph';
	eval 'sub pcibios_assign_all_busses () {
	    eval q(0);
	}' unless defined(&pcibios_assign_all_busses);
	eval 'sub PCIBIOS_MIN_IO () {0;}' unless defined(&PCIBIOS_MIN_IO);
	eval 'sub PCIBIOS_MIN_MEM () {0;}' unless defined(&PCIBIOS_MIN_MEM);
	eval 'sub PCI_IRQ_NONE () {0xffffffff;}' unless defined(&PCI_IRQ_NONE);
	eval 'sub PCI_DMA_BUS_IS_PHYS () {(0);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	require 'asm/scatterlist.ph';
	eval 'sub pci_map_page {
	    local($dev, $page, $off, $size, $dir) = @_;
    	    eval q( &pci_map_single($dev, ( &page_address($page) + ($off)), $size, $dir));
	}' unless defined(&pci_map_page);
	eval 'sub pci_unmap_page {
	    local($dev,$addr,$sz,$dir) = @_;
    	    eval q( &pci_unmap_single($dev,$addr,$sz,$dir));
	}' unless defined(&pci_unmap_page);
	eval 'sub DECLARE_PCI_UNMAP_ADDR {
	    local($ADDR_NAME) = @_;
    	    eval q( &dma_addr_t $ADDR_NAME;);
	}' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	eval 'sub DECLARE_PCI_UNMAP_LEN {
	    local($LEN_NAME) = @_;
    	    eval q( &__u32 $LEN_NAME;);
	}' unless defined(&DECLARE_PCI_UNMAP_LEN);
	eval 'sub pci_unmap_addr {
	    local($PTR, $ADDR_NAME) = @_;
    	    eval q((($PTR)->$ADDR_NAME));
	}' unless defined(&pci_unmap_addr);
	eval 'sub pci_unmap_addr_set {
	    local($PTR, $ADDR_NAME, $VAL) = @_;
    	    eval q(((($PTR)->$ADDR_NAME) = ($VAL)));
	}' unless defined(&pci_unmap_addr_set);
	eval 'sub pci_unmap_len {
	    local($PTR, $LEN_NAME) = @_;
    	    eval q((($PTR)->$LEN_NAME));
	}' unless defined(&pci_unmap_len);
	eval 'sub pci_unmap_len_set {
	    local($PTR, $LEN_NAME, $VAL) = @_;
    	    eval q(((($PTR)->$LEN_NAME) = ($VAL)));
	}' unless defined(&pci_unmap_len_set);
	eval 'sub PCI64_REQUIRED_MASK () {(~0);}' unless defined(&PCI64_REQUIRED_MASK);
	eval 'sub PCI64_ADDR_BASE () {1.84456181738027e+19;}' unless defined(&PCI64_ADDR_BASE);
	eval 'sub pci_dac_dma_supported {
	    local($pci_dev, $mask) = @_;
    	    eval q((((($mask) &  &PCI64_REQUIRED_MASK) ==  &PCI64_REQUIRED_MASK) ? 1: 0));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub HAVE_PCI_MMAP () {1;}' unless defined(&HAVE_PCI_MMAP);
	eval 'sub HAVE_ARCH_PCI_GET_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_PCI_GET_UNMAPPED_AREA);
	eval 'sub get_pci_unmapped_area () { &get_fb_unmapped_area;}' unless defined(&get_pci_unmapped_area);
    }
}
1;
